//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TIntThread : public TThread
{
public:
    __fastcall TIntThread();
    __fastcall TIntThread(bool EnableStatus, bool EnableTimerInterrupt);

private:
    void __fastcall Execute(void);
    USHORT GetInterruptID(void);
    
    LRESULT     ErrCde;                     // Return error code
    char        szErrMsg[80];               // Use for MESSAGEBOX function

    PT_WritePortByte    P833WritePortByte;
    PT_ReadPortByte     P833ReadPortByte;
    PT_CheckEvent	    ptCheckEvent;

    USHORT      InterruptID;
    ULONG       P833DriverHandle;
    USHORT      P833BaseAddress;
    bool        P833TimerINT;
};
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu1;
    TMenuItem *SelectDevice1;
    TMenuItem *Open1;
    TMenuItem *Exit1;
    TMenuItem *Help1;
    TMenuItem *Conetent1;
    TMenuItem *About1;
    TMenuItem *Initialize8331;
    TMenuItem *AddDevice1;
    TMenuItem *N1;
    TMenuItem *N2;
    TMenuItem *N3;
    TMenuItem *Function1;
    TMenuItem *Base1;
    TMenuItem *Advance1;
    TMenuItem *N4;
    TMenuItem *N5;
    TMenuItem *WithPCL8391;
    TMenuItem *OneChannel1;
    TMenuItem *TwoChannel1;
    TMenuItem *ThreeChannel1;
    TPageControl *PageControl1;
    TTabSheet *TabSheet1;
    TTabSheet *TabSheet2;
    TTabSheet *TabSheet3;
    TGroupBox *GroupBox1;
    TEdit *Edit1;
    TLabel *Label1;
    TLabel *Label2;
    TComboBox *ComboBox1;
    TLabel *Label3;
    TRadioGroup *RadioGroup1;
    TRadioButton *RadioButton1;
    TRadioButton *RadioButton2;
    TLabel *Label4;
    TComboBox *ComboBox2;
    TCheckBox *CheckBox1;
    TCheckBox *CheckBox2;
    TButton *Button1;
    TGroupBox *GroupBox2;
    TLabel *Label5;
    TLabel *Label6;
    TLabel *Label7;
    TLabel *Label8;
    TEdit *Edit2;
    TComboBox *ComboBox3;
    TRadioGroup *RadioGroup2;
    TRadioButton *RadioButton3;
    TRadioButton *RadioButton4;
    TComboBox *ComboBox4;
    TCheckBox *CheckBox3;
    TCheckBox *CheckBox4;
    TButton *Button2;
    TGroupBox *GroupBox3;
    TLabel *Label9;
    TLabel *Label10;
    TLabel *Label11;
    TLabel *Label12;
    TEdit *Edit3;
    TComboBox *ComboBox5;
    TRadioGroup *RadioGroup3;
    TRadioButton *RadioButton5;
    TRadioButton *RadioButton6;
    TComboBox *ComboBox6;
    TCheckBox *CheckBox5;
    TCheckBox *CheckBox6;
    TButton *Button3;
    TTimer *Timer1;
    TMenuItem *Close1;
    TLabel *Label13;
    TGroupBox *GroupBox4;
    TShape *Shape1;
    TShape *Shape2;
    TShape *Shape3;
    TShape *Shape4;
    TShape *Shape5;
    TButton *Button4;
    TGroupBox *GroupBox6;
    TGroupBox *GroupBox5;
    TRadioButton *RadioButton7;
    TRadioButton *RadioButton8;
    TButton *Button5;
    TLabel *Label14;
    TLabel *Label15;
    TLabel *Label16;
    TEdit *Edit6;
    TEdit *Edit5;
    TEdit *Edit4;
    TLabel *Label17;
    void __fastcall AddDevice1Click(TObject *Sender);
    
    
    void __fastcall Open1Click(TObject *Sender);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    
    void __fastcall About1Click(TObject *Sender);
    void __fastcall OneChannel1Click(TObject *Sender);
    void __fastcall TwoChannel1Click(TObject *Sender);
    void __fastcall ThreeChannel1Click(TObject *Sender);
    void __fastcall Base1Click(TObject *Sender);
    void __fastcall Advance1Click(TObject *Sender);
    void __fastcall WithPCL8391Click(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    bool __fastcall FormHelp(WORD Command, int Data, bool &CallHelp);
    void __fastcall Conetent1Click(TObject *Sender);

    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall Button2Click(TObject *Sender);
    void __fastcall Button3Click(TObject *Sender);
    void __fastcall Close1Click(TObject *Sender);
    void __fastcall Initialize8331Click(TObject *Sender);
    void __fastcall Button4Click(TObject *Sender);
    void __fastcall Button5Click(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    
private:	// User declarations
    // For Basic function
    char        szErrMsg[80];               // Use for MESSAGEBOX function
    LRESULT     ErrCde;                     // Return error code
    LONG        DriverHandle;               // driver handle
    USHORT      DeviceAddress;              // Base Address of selected PCL-833
    USHORT      TimeBase;                   // Time Base setting of selected PCL-833

    PT_QCounterRead    ptQCounterRead;      // For QCounterRead() function
    USHORT usOverflow;                      // counter over 32 bit flag
    ULONG  ulLoCount;                       // low byte of counter
    ULONG  ulHiCount;                       // high byte of counter

    PT_DioReadPortByte ptDioReadPortByte;
    USHORT      gwValue;

    char        szBuffer[40];				// Temperatory buffer
    int szBuf1[20];                         /* temp buffer */
    int szBuf2[20];                         /* temp buffer */

    // For Advance function
    TIntThread *AdvanceThread;

    void    QCounterConfig(USHORT channel);
    void    QCounterStart(USHORT channel);
    void    CounterReset(USHORT channel);
    BOOL    GetKeyValue(HKEY  hkReg, PCHAR pszName, LPVOID pItem, USHORT usNum);
public:		// User declarations
    __fastcall TForm1(TComponent* Owner);

    LONG        GetDriverHandle(void);               // driver handle
    USHORT      GetDeviceAddress(void);              // Base Address of selected PCL-833
    USHORT      GetTimeBase(void);

    BOOL        bRun;
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
