//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "DisplayForm.h"
#include "GainListForm.h"
#include "MainForm.h"
#include "stdio.h"
#include "..\..\..\include\driver.h"

#include "MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

//---------------------------------------------------------------------------

#define     MAX_DEVICES     100

DEVFEATURES     DevFeatures;    // structure for device features
static      PT_DeviceGetFeatures  ptDevFeatures;
static      PT_FAIDmaExStart   ptFAIDmaExStart;   // FAIIntStart table
static      PT_FAITransfer     ptFAITransfer;     // FAITransfer table
static      PT_FAICheck        ptFAICheck;        // FAICheck table
static      PT_EnableEvent     ptEnableEvent;     // Enable event
static      PT_CheckEvent      ptCheckEvent;      // Check event
static      PT_AIGetConfig  lpAIGetConfig;
DEVCONFIG_AI   lpDevConfig_AI ;
HGLOBAL     hUserBuf, hDisplayBuf;

static  DWORD  gdwPacerRate = 250000;               // pacer rate
static  ULONG  gulConvNum   = 200000;//40960;               // conversion number
USHORT gwStartChl   = 0, gwChlNum = 1;   // scan channels
static  USHORT gwDataType   = 1;                  // display type : FLOAT(1)
static  USHORT gwEvtFlag    = 1;                  // event enable(0)
static  ULONG  gwActualBufSize = 0;               // actual allocate buffer size
static  USHORT gwFifoEnable    = 0;               // Fifo disable(0)

static  USHORT gwGainList = 0;      // gain list flag
static  ULONG  gdwStartPt = 0, gdwStopPt = 99;    // display points
static  USHORT gwExtTrig  = 0;      // external or internal trigger
static  USHORT gwClockSrc = 0;		// Clock source
static  USHORT gwTrigEdge = 0;		// Trigger edge
static  USHORT gwSRCType  = 0;	   // Source type
static  FLOAT  gwTrigVol  = 0.0;		// Trigger voltage

static  USHORT gwCyclicMode = 1;    // cyclic or non-cyclic mode
static  USHORT gwTrigMode   = 0;    // Trigger Mode
static  USHORT gwIntrCount  = 1;
static  ULONG  gwCyclicCount= 1;    // number of cyclic count

static  USHORT gwActiveBuf = 0;     // return by FAICheck
static  USHORT gwOverrun   = 0;     // return by FAICheck, FAITransfer
static  USHORT gwStopped   = 0;     // return by FAICheck
static  ULONG gulRetrieved = 0;     // return by FAICheck
static  USHORT gwHalfReady = 0;     // return by FAICheck
static  ULONG gwDelayCnt   = 2;

bool    bThreadloop = true;

int      gwDevice = 0, gwSubDevice = 0;      // Device index

SHORT       gnNumOfDevices, gnNumOfSubdevices;  // number of installed devices

char        szErrMsg[80];               // Use for MESSAGEBOX function
char        szBuffer[40];				// Temperatory buffer
LRESULT     ErrCde;                     // Return error code

DEVLIST     DeviceList[MAX_DEVICES];
DEVLIST     SubDeviceList[MAX_DEVICES];
static  LONG   DriverHandle = (LONG)NULL;         // driver handle
FLOAT       fVoltageArray[32];

USHORT gwGainCde[64],ReorderGainCode[64];
SHORT gwGain[64];
USHORT      usGainIndx[64];
USHORT      usStartChan, usChanNum;
ULONG gulIntCounter     = 0;  // counter by adInterruptEvent
ULONG gulBfChgCounter   = 0;
ULONG gulOverrunCounter = 0;
ULONG gulOverrunTime  = 10000;  // 0 = INFINITE
ULONG gulEventCount   = 1;    
char  szCounter[40];
BOOL  bBufferChange = 1;
BOOL  bInterrupt = 1;
BOOL  bOverrun   = 1;
BOOL  bTerminate = 1;


TfrmMain *frmMain;

//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
    int         nOutEntries;

    for(int i=0;i<64;i++)
       gwGain[i]=0;



    if ((ErrCde = DRV_DeviceGetNumOfList((SHORT far *)&gnNumOfDevices)) !=
        SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
        exit(0);
    }

    if (gnNumOfDevices > MAX_DEVICES)
        gnNumOfDevices = MAX_DEVICES;

    // Add type of PC Laboratory Card
    if ((ErrCde = DRV_DeviceGetList((DEVLIST far *) &DeviceList[0],
        (SHORT)gnNumOfDevices, (SHORT far *)&nOutEntries)) != (LONG)SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
        exit(0);
    }

    // Here MaxEntries = nOutEntries
    for(int i = 0; i < gnNumOfDevices ; i++)
        lstDevice->Items->Add((LPSTR)DeviceList[i].szDeviceName);

    lstDevice->ItemIndex = gwDevice;
    lstDeviceClick(Sender);

    butStop->Enabled = False;



}
//---------------------------------------------------------------------------



void __fastcall TfrmMain::lstDeviceClick(TObject *Sender)
{

       USHORT i;

    cmbGain->Clear();
    gwDevice = lstDevice->ItemIndex;
    if(  gwDevice < 0)
    {
        Application->MessageBox("No installed device!", "Driver Message", MB_OK);
        return;
        }

    ErrCde = DRV_DeviceOpen(DeviceList[gwDevice].dwDeviceNum,
             (LONG far *)&DriverHandle);
    if (ErrCde != SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);

    }

    // get device features
    ptDevFeatures.buffer = (LPDEVFEATURES)&DevFeatures;
    ptDevFeatures.size = sizeof(DEVFEATURES);
    if ((ErrCde = DRV_DeviceGetFeatures(DriverHandle,
        (LPT_DeviceGetFeatures)&ptDevFeatures)) != SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        DRV_DeviceClose((LONG far *)&DriverHandle);
        Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
  
    }
    lpAIGetConfig.size = sizeof(LPDEVCONFIG_AI);
    lpAIGetConfig.buffer = &lpDevConfig_AI;
    ErrCde = DRV_AIGetConfig(DriverHandle, &lpAIGetConfig);
    if (ErrCde != SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
        DRV_DeviceClose(&DriverHandle);
        butStart->Enabled = false;
        return;

    }
    // initialize Input Range List Combobox with device features
    if (DevFeatures.usNumGain != 0)
    {

        for (i = 0; i < DevFeatures.usNumGain; i ++)
           cmbGain->Items->Add((LPSTR)DevFeatures.glGainList[i].szGainStr);

        cmbGain->ItemIndex = 0;
    }


    // Initialize Start Channel
    cmbChannel->Clear();
    for (i = 0 ; i < DevFeatures.usMaxAISiglChl ; i++)
    {
        itoa((int)i, szBuffer, 10);
        cmbChannel->Items->Add((LPSTR)szBuffer);
        cmbChannel->ItemIndex = 0;

    }
    char buff[20];
    sprintf(buff,"%d",  DevFeatures.usMaxAISiglChl);
    editScanNum->Text = buff ;

    // close device
    DRV_DeviceClose((LONG far *)&DriverHandle);

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::butStartClick(TObject *Sender)
{

     gwTrigVol = editTrigVolt->Text.ToDouble();
     gwDelayCnt = editDelayCount->Text.ToInt();
     gdwPacerRate = editPacerRate->Text.ToInt();
     gulConvNum = editCount->Text.ToInt();
     gwStartChl = cmbChannel->ItemIndex;
     gwChlNum =  editScanNum->Text.ToInt();

     if(radInternal->Checked)
          gwExtTrig=0;
     else
          gwExtTrig=1;     
     int temp;

      int phiChan = usStartChan;

      for (int i=0 ; i< gwChlNum ; i++, phiChan++)
    {
       gwGainCde[i] =
         DevFeatures.glGainList[gwGain[usStartChan+phiChan]].usGainCde;
      if( lpDevConfig_AI.ulChanConfig & (1<< phiChan) )
        phiChan++;

    }


     for(int i=0; i<gwChlNum; i++)
     {
         temp = gwStartChl + i;
       	 if(temp>15)
     	    temp = temp - 16;

      	ReorderGainCode[i] =  gwGainCde[temp];
     }


    ErrCde = DRV_DeviceOpen(DeviceList[gwDevice].dwDeviceNum,
             (LONG far *)&DriverHandle);
    if (ErrCde != SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
        exit(0);
    }


      // allocate memory
     if((hUserBuf=(USHORT far *)GlobalAlloc(GHND, sizeof(USHORT) * gulConvNum)) == 0)
     {
         lstrcpy((char *) szErrMsg, "Not enough memory for buffer");
         DRV_DeviceClose((LONG far *)&DriverHandle);
         Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
         return;
     }

     // allocate memory
     if((hDisplayBuf=(FLOAT far *)GlobalAlloc(GHND, sizeof(FLOAT) * gulConvNum)) == 0)
     {
         lstrcpy((char *) szErrMsg, "Not enough memory for buffer");
         DRV_DeviceClose((LONG far *)&DriverHandle);
         Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
         return;
     }

     ptFAITransfer.DataBuffer = (FLOAT far  *)GlobalLock(hDisplayBuf);

     // enable event
        ptEnableEvent.EventType = 0;
        if( chkBufferChange->Checked )
        {
            ptEnableEvent.EventType |= ADS_EVT_BUFCHANGE;
        }
        if( chkTerminate->Checked )
        {
            ptEnableEvent.EventType |= ADS_EVT_TERMINATED;
        }
        if( chkOverrun->Checked )
        {
            ptEnableEvent.EventType |= ADS_EVT_OVERRUN;
        }
        if( chkInterrupt->Checked )
        {
            ptEnableEvent.EventType |= ADS_EVT_INTERRUPT;
        }
       
        ptEnableEvent.Enabled = true;
        ptEnableEvent.Count   = (USHORT)(edtEventCount->Text.ToInt() * 2048);


     if ((ErrCde = DRV_EnableEvent(DriverHandle,
         (LPT_EnableEvent)&ptEnableEvent)) != 0)
     {
         DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);

         GlobalUnlock(hUserBuf);
         GlobalFree(hUserBuf);
         DRV_DeviceClose((LONG far *)&DriverHandle);
         Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
         return;
     }

      ptFAIDmaExStart.TrigSrc	    	= gwExtTrig;
      ptFAIDmaExStart.TrigMode		= gwTrigMode;
      ptFAIDmaExStart.ClockSrc		= gwClockSrc;
      ptFAIDmaExStart.TrigEdge		= gwTrigEdge;
      ptFAIDmaExStart.SRCType	      	= gwSRCType;
      ptFAIDmaExStart.CyclicMode     	= gwCyclicMode;
      ptFAIDmaExStart.TrigVol	     	= gwTrigVol;
      ptFAIDmaExStart.StartChan		= gwStartChl;
      ptFAIDmaExStart.NumChans		= gwChlNum;
      ptFAIDmaExStart.ulDelayCnt     	= gwDelayCnt;
      ptFAIDmaExStart.SampleRate     	= gdwPacerRate;
      ptFAIDmaExStart.GainList		= &ReorderGainCode[0];
      ptFAIDmaExStart.count	      	= gulConvNum;
      ptFAIDmaExStart.buffer0	      	= (USHORT *)hUserBuf;

      if ((ErrCde = DRV_FAIDmaExStart(DriverHandle,
          (LPT_FAIDmaExStart)&ptFAIDmaExStart)) != 0)
      {
          DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
          Application->MessageBox((LPCSTR)szErrMsg,"Driver Message",MB_OK);
          VirtualFree(
                       hUserBuf,
                       2 * gulConvNum,
                       MEM_DECOMMIT| MEM_RELEASE);
          DRV_DeviceClose((LONG far *)&DriverHandle);
          return ;
       }
    frmDisplay->Show();
    frmDisplay->lstBuffer->Hide();

     butStart->Enabled = False;
     butStop->Enabled  = True;
     butExit->Enabled  = False;
  
    butStop->Enabled = true;
    butStart->Enabled = false;
    lstDevice->Enabled = false;
    editScanNum->Enabled = false;
    cmbGain->Enabled = false;
    cmbChannel->Enabled = false;
    gulOverrunTime = editOverrunTime->Text.ToInt();


    bThreadloop = true;

    pThread = new MyThread(false);
    


 
    

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::butStopClick(TObject *Sender)
{
   bThreadloop= false;
   Sleep(100);
   pThread->Terminate();
   char szData[40];
    butStop->Enabled = false;
   butStart->Enabled = true;
   lstDevice->Enabled = true;
    editScanNum->Enabled = true;
    cmbGain->Enabled = true;
    cmbChannel->Enabled = true;
    butExit->Enabled  = true;
  if ((ErrCde = DRV_FAIStop(DriverHandle)) != 0)
   {
      DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
      Application->MessageBox((LPCSTR)szErrMsg,"Thread Message",MB_OK);
      return ;
   }
   DWORD ExitCode;

   GetExitCodeThread((void*)(pThread->Handle),&ExitCode);
   if(ExitCode==STILL_ACTIVE)
      TerminateThread((void*)(pThread->Handle),ExitCode);

   // Get real voltage of buffer from driver
   ptFAITransfer.ActiveBuf = 0;   // single buffer
   ptFAITransfer.DataType = gwDataType;
   ptFAITransfer.start    = 0;
   ptFAITransfer.count    = gulConvNum;
   ptFAITransfer.overrun  = &gwOverrun;

   if ((ErrCde = DRV_FAITransfer(DriverHandle,
       (LPT_FAITransfer)&ptFAITransfer)) != 0)
   {
       DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
       Application->MessageBox((LPCSTR)szErrMsg,"Thread Message",MB_OK);

   }

   // Display data
   frmDisplay->Show();
   frmDisplay->lstBuffer->Show();
   frmDisplay->lstBuffer->Clear();

      for ( int i=0; i<gwChlNum; i++ )
    {
        if ( gwDataType )
        {
           sprintf( szData, "chan[ %d ] = %8.6f", i+gwStartChl,
              ((float*)ptFAITransfer.DataBuffer)[i] );
        }
        else
        {
           sprintf( szData, "chan[ %d ] = %X", i+gwStartChl,
              ((USHORT *)ptFAITransfer.DataBuffer)[i] );                                 
        }
        frmDisplay->lstBuffer->Items->Add(szData);
    }

   // Free buffer
   GlobalUnlock(hDisplayBuf);
   GlobalFree(hDisplayBuf);
   GlobalUnlock(hUserBuf);
   GlobalFree( hUserBuf);
   // Close driver
     ErrCde = DRV_DeviceClose((LONG far *)&DriverHandle);
    if (ErrCde != SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
     }





}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::OnDestroy(TObject *Sender)
{
      if( butStop->Enabled )
        butStopClick(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::butExitClick(TObject *Sender)
{
   Close();

}
//---------------------------------------------------------------------------
__fastcall MyThread::MyThread(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall MyThread::Execute()
{
        //---- Place thread code here ----

         frmMain->CheckEvent();


}
//---------------------------------------------------------------------------


void TfrmMain::CheckEvent()
{
    //TODO: Add your source code here
    USHORT usEventType;
    char szData[32];
    gulIntCounter = 0;
    gulBfChgCounter = 0;
    gulOverrunCounter = 0;

    while( bThreadloop )
    {
        ptCheckEvent.EventType = &usEventType;
        if ( gulOverrunTime==0 )
        { 
            ptCheckEvent.Milliseconds = INFINITE;
        }
        else
        {
            ptCheckEvent.Milliseconds = gulOverrunTime;
        }


        if ((ErrCde = DRV_CheckEvent(DriverHandle,
            (LPT_CheckEvent)&ptCheckEvent)) != 0)
        {
           Application->MessageBox("Check Event Error !","Thread Message",MB_OK);
		


        }

        // Process interrupt event
        if (usEventType & ADS_EVT_INTERRUPT)
        {
            InterruptEvent();
        }

        // Process buffer change event
        if (usEventType & ADS_EVT_BUFCHANGE)
            BufChangeEvent();

        // Process overrun event
        if (usEventType & ADS_EVT_OVERRUN)
        {
            OverrunEvent();
        }

        // Process terminate event
        if (usEventType & ADS_EVT_TERMINATED)
        {
            TerminateEvent();
            return;
        }
        frmDisplay->Canvas->Lock();
        sprintf( szCounter, "Interrupt Counter = %4d\n", gulIntCounter );
        frmDisplay->Canvas->TextOut(20, 40, szCounter );
        sprintf( szData, "Buffer change Counter = %4d\n", gulBfChgCounter );
        frmDisplay->Canvas->TextOut( 20, 60, szData );
        sprintf( szData, "Overrun Counter = %4d\n", gulOverrunCounter );
        frmDisplay->Canvas->TextOut( 20, 80, szData );
        frmDisplay->Canvas->Unlock();
   }

}




void __fastcall TfrmMain::radGainListClick(TObject *Sender)
{
   butGainList->Enabled = true;
   cmbGain->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radOverallClick(TObject *Sender)
{
   butGainList->Enabled = false;
   cmbGain->Enabled = true;
     for(int i=0;i<64;i++)
       gwGain[i]=cmbGain->ItemIndex;


}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::butGainListClick(TObject *Sender)
{

 
    int temp=0;
    char tempstr[80];
    usStartChan = cmbChannel->ItemIndex;
    usChanNum =  editScanNum->Text.ToInt();
    for(int i=usStartChan; i< DevFeatures.usMaxAISiglChl; i++)
    {
        if( lpDevConfig_AI.ulChanConfig  & (1 << i) )
            i++;
        temp++;
  }

    if( usChanNum > temp)
    {
       sprintf(tempstr," Maximum of the Scan Channnel Number is %d.",temp);
       Application->MessageBox(tempstr,"Channel Error", MB_OK);
       return;
     }

    frmGainList->SetGainList();
    frmGainList->ShowModal();


}
//---------------------------------------------------------------------------


void TfrmMain::InterruptEvent()
{
   //TODO: Add your source code here
   gulIntCounter++;



}

void TfrmMain::BufChangeEvent()
{
    //TODO: Add your source code here
    int i;
    char szData[32];

   gulBfChgCounter++;
   gwCyclicCount = gulBfChgCounter/2;

   // Get DMA transfer status
   ptFAICheck.ActiveBuf = &gwActiveBuf;
   ptFAICheck.stopped   = &gwStopped;
   ptFAICheck.retrieved = &gulRetrieved;
   ptFAICheck.overrun   = &gwOverrun;
   ptFAICheck.HalfReady = &gwHalfReady;

   if ((ErrCde = DRV_FAICheck(DriverHandle,
       (LPT_FAICheck)&ptFAICheck)) != 0)
   {
       DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
       Application->MessageBox((LPCSTR)szErrMsg,"Driver Message",MB_OK);
       DRV_FAIStop( DriverHandle );
       DRV_DeviceClose((LONG *)&DriverHandle );
       GlobalFree( hUserBuf ); 
       return ;
   }
 
    // When call DRV_FAITransfer( ), the overrun event flag will be cleaned,
    // otherwise, the application will receive overrun event continously.
    // Get real voltage of buffer from driver
    ptFAITransfer.ActiveBuf = 0;   // single buffer
    ptFAITransfer.DataType = gwDataType;

    if ( 2==gwHalfReady )
    {
       ptFAITransfer.start = gulConvNum / 2;
    }
    else
    {
       ptFAITransfer.start = 0;
    }

    if ( gulConvNum >= 20 )
    {
       ptFAITransfer.count = 10; // For demo, we only get few data
    }
    else
    {
       ptFAITransfer.count = 1;  // For demo, we only get few data
    }
    ptFAITransfer.overrun  = &gwOverrun;

    if ((ErrCde = DRV_FAITransfer(DriverHandle,
        (LPT_FAITransfer)&ptFAITransfer)) != 0)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBox((LPCSTR)szErrMsg,"Thread Message",MB_OK);
        return ;
    }
    frmDisplay->Canvas->Lock();
    frmDisplay->Canvas->Font->Color = clBlue;
    for ( i=0; i<10; i++ )
    {
        if ( gwDataType )
        {
           sprintf( szData, "Buf[ %07d ]=%8.6f", i+ptFAITransfer.start,
              ((float*)ptFAITransfer.DataBuffer)[i] );
        }
        else
        {
           sprintf( szData, "Buf[ %07d ]=%   X", i+ptFAITransfer.start,
              ((USHORT *)ptFAITransfer.DataBuffer)[i] );                                 
        }
        frmDisplay->Canvas->TextOutA( 20, 120+ 20*i, szData );
    }
        frmDisplay->Canvas->Unlock();

}

void TfrmMain::OverrunEvent()
{
        //TODO: Add your source code here
    gulOverrunCounter++;
    DRV_ClearOverrun(  DriverHandle );
}

void TfrmMain::TerminateEvent()
{
        //TODO: Add your source code here
    char szData[40];
    if ((ErrCde = DRV_FAIStop(DriverHandle)) != 0)
   {
      DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
      Application->MessageBox((LPCSTR)szErrMsg,"Thread Message",MB_OK);
      return ;
   }
   // Get real voltage of buffer from driver
   ptFAITransfer.ActiveBuf = 0;   // single buffer
   ptFAITransfer.DataType = gwDataType;
   ptFAITransfer.start    = 0;
   ptFAITransfer.count    = gulConvNum;
   ptFAITransfer.overrun  = &gwOverrun;

   if ((ErrCde = DRV_FAITransfer(DriverHandle,
       (LPT_FAITransfer)&ptFAITransfer)) != 0)
   {
       DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
       Application->MessageBox((LPCSTR)szErrMsg,"Thread Message",MB_OK);

   }

   // Display data
   frmDisplay->Show();
   frmDisplay->lstBuffer->Clear();
   frmDisplay->lstBuffer->Show();

    for ( int i=0; i<gwChlNum; i++ )
    {
        if ( gwDataType )
        {
           sprintf( szData, "chan[ %d ] = %8.6f", i+gwStartChl,
              ((float*)ptFAITransfer.DataBuffer)[i] );
        }
        else
        {
           sprintf( szData, "chan[ %d ] = %X", i+gwStartChl,
              ((USHORT *)ptFAITransfer.DataBuffer)[i] );                                 
        }
        frmDisplay->lstBuffer->Items->Add(szData);
    }

   // Free buffer
   GlobalUnlock(hDisplayBuf);
   GlobalFree(hDisplayBuf);
   GlobalUnlock(hUserBuf);
   GlobalFree( hUserBuf);
   // Close driver
     ErrCde = DRV_DeviceClose((LONG far *)&DriverHandle);
    if (ErrCde != SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
     }

    butStop->Enabled = false;
    butStart->Enabled = true;
    lstDevice->Enabled = true;
    editScanNum->Enabled = true;
    cmbGain->Enabled = true;
    cmbChannel->Enabled = true;
    butExit->Enabled  = true;
 

}
void __fastcall TfrmMain::radInternalClick(TObject *Sender)
{
        gwExtTrig=0;

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radExternalClick(TObject *Sender)
{
        gwExtTrig=1;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radDelayClick(TObject *Sender)
{
   editDelayCount->Enabled=true;
   radFalling->Enabled = true;
   radRising->Enabled = true;
   radDigital->Enabled = true;
   radAI0->Enabled = true;
   radAI1->Enabled = true;
   radAI2->Enabled = true;
   radAI3->Enabled = true;
   radExternal->Checked=true;
   gwTrigMode=2;
   gwTrigEdge=1;
   radFalling->Checked = true;
   radCyclic->Enabled = true;
   radNonCyclic->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radPostClick(TObject *Sender)
{
   editDelayCount->Enabled=false;
   radFalling->Enabled = true;
   radRising->Enabled = true;
    radDigital->Enabled = true;
   radAI0->Enabled = true;
   radAI1->Enabled = true;
   radAI2->Enabled = true;
   radAI3->Enabled = true;
   radExternal->Checked=true;
   gwTrigMode=1;
   gwTrigEdge=1;
   radFalling->Checked = true;
   radCyclic->Enabled = true;
   radNonCyclic->Enabled = true;


}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radAboutClick(TObject *Sender)
{
   editDelayCount->Enabled=true;
   radFalling->Enabled = true;
   radRising->Enabled = true;
    radDigital->Enabled = true;
   radAI0->Enabled = true;
   radAI1->Enabled = true;
   radAI2->Enabled = true;
   radAI3->Enabled = true;
   radExternal->Checked=true;
   gwTrigMode=3;
   gwTrigEdge=0;
   radRising->Checked = true;
   radCyclic->Enabled = false;
   radNonCyclic->Enabled = false;
}

//---------------------------------------------------------------------------

void __fastcall TfrmMain::radPacerClick(TObject *Sender)
{
   editDelayCount->Enabled=false;
   radFalling->Enabled = false;
   radRising->Enabled = false;
    radDigital->Enabled = false;
   radAI0->Enabled = false;
   radAI1->Enabled = false;
   radAI2->Enabled = false;
   radAI3->Enabled = false;
   radInternal->Checked = true;
   gwTrigMode=0;
   radCyclic->Enabled = true;
   radNonCyclic->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radClockInternalClick(TObject *Sender)
{
    editPacerRate->Enabled = true;
    gwClockSrc = 0;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radClockExternal0Click(TObject *Sender)
{
     editPacerRate->Enabled = false;
     gwClockSrc = 1;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radClockExternal1Click(TObject *Sender)
{
     editPacerRate->Enabled = false;
     gwClockSrc =2;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radDigitalClick(TObject *Sender)
{
   editTrigVolt->Enabled = false;
   gwSRCType = 0;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radAI0Click(TObject *Sender)
{
   editTrigVolt->Enabled = true;
   gwSRCType = 1;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radAI1Click(TObject *Sender)
{
   editTrigVolt->Enabled = true;
   gwSRCType = 2;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radAI2Click(TObject *Sender)
{
   editTrigVolt->Enabled = true;
    gwSRCType = 3;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radAI3Click(TObject *Sender)
{
   editTrigVolt->Enabled = true;
    gwSRCType = 4;       
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::radRisingClick(TObject *Sender)
{
    gwTrigEdge=0;
        
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radFallingClick(TObject *Sender)
{

   gwTrigEdge = 1;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radCyclicClick(TObject *Sender)
{
     gwCyclicMode = 1;
        
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radNonCyclicClick(TObject *Sender)
{
     gwCyclicMode = 0;

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radRawDataClick(TObject *Sender)
{
      gwDataType = 0;
        
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::radVoltageClick(TObject *Sender)
{
     gwDataType = 1;
}

void __fastcall TfrmMain::cmbGainChange(TObject *Sender)
{
   for(int i=0;i<64;i++)
     gwGain[i]= cmbGain->ItemIndex;
        
}
//---------------------------------------------------------------------------






