//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormRun.h"
#include "FormStart.h"
#include "..\..\..\include\driver.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm2 *Form2;

PT_AIVoltageIn ptAIVolIn;
extern PT_AIConfig ptAIConfig;
extern long DeviceHandle;
extern int AICtrMode;
extern long ErrCde;
extern char szErrMsg[80];

//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm2::FormCreate(TObject *Sender)
{
    hscrFreqChange(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm2::CmdReadClick(TObject *Sender)
{
    Single voltage;

    tmrRead->Enabled = False;

    ptAIVolIn.chan = ptAIConfig.DasChan;
    ptAIVolIn.gain = ptAIConfig.DasGain;
    ptAIVolIn.TrigMode = AICtrMode;
    ptAIVolIn.voltage = &voltage;
    shapLed->Brush->Color = clRed;

    ErrCde = DRV_AIVoltageIn(DeviceHandle, &ptAIVolIn);
    if (ErrCde != 0)
    {
        DRV_GetErrorMessage(ErrCde, szErrMsg);
        Application->MessageBox(szErrMsg, "Error!!", MB_OK);
        return;
    }

    txtVoltRead->Text = FloatToStrF(voltage, ffFixed, 5, 2);
}
//---------------------------------------------------------------------------

void __fastcall TForm2::hscrFreqChange(TObject *Sender)
{
    if (hscrFreq->Position == 0)
        tmrRead->Interval = 0;
    else
        tmrRead->Interval = 10000 / hscrFreq->Position;
    
    txtSample->Text = FloatToStrF((hscrFreq->Position / 10.0), ffFixed, 5, 2);

    // "Read One Shot" would disable the "tmrRead" Timer,
    // so it need to enable here.
    tmrRead->Enabled = True;
    tmrLed->Enabled = True;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::txtVoltReadClick(TObject *Sender)
{
    tmrRead->Enabled = True;
    tmrLed->Enabled = True;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::tmrReadTimer(TObject *Sender)
{
    Single voltage;

    shapLed->Brush->Color = clRed;
    ptAIVolIn.chan = ptAIConfig.DasChan;
    ptAIVolIn.gain = ptAIConfig.DasGain;
    ptAIVolIn.TrigMode = AICtrMode;
    ptAIVolIn.voltage = &voltage;

    ErrCde = DRV_AIVoltageIn(DeviceHandle, &ptAIVolIn);
    if (ErrCde != 0)
    {
        DRV_GetErrorMessage(ErrCde, szErrMsg);
        Application->MessageBox(szErrMsg, "Error!!", MB_OK);
        return;
    }

    txtVoltRead->Text = FloatToStrF(voltage, ffFixed, 5, 2);
}
//---------------------------------------------------------------------------

void __fastcall TForm2::tmrLedTimer(TObject *Sender)
{
    shapLed->Brush->Color = clGray;        
}
//---------------------------------------------------------------------------

void __fastcall TForm2::CmdExitClick(TObject *Sender)
{
    Form2->Close();
    Form1->Show();
    Form1->cmdExit->SetFocus();
}
//---------------------------------------------------------------------------

