//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "frmMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
        int   i;
        FLOAT ratio;
        char  szBuf_IDI[ 4 ][20];
	char  DeviceName[ 50 ];

        editScanTime->Text = "1000";
	editChan->Text = "0";
	editCount_DI1->Text = "1";
        editCount_DI0->Text = "1";
        editCount_IDI0->Text = "1";
        editCount_IDI1->Text = "1";
	m_DriverHandle = (LONG)NULL;          // driver handle
	m_bContinue    = FALSE;
	m_bHiPriority  = FALSE;
	m_bFlag     = FALSE;
	m_bDI0Flag  = FALSE;
	m_bDI1Flag  = FALSE;
        m_bIDI0Flag = FALSE;
	m_bIDI1Flag = FALSE;
        m_StartFlag = 0;
        pEventThread=NULL;

        for ( i = 0; i < 4; i++ )
        {
           ratio = 0.0;
           sprintf( szBuf_IDI[i], "%.3f", ratio );
        }

        editIntCount_IDI0->Text = szBuf_IDI[0];
        editIntCount_IDI1->Text = szBuf_IDI[1];
        editIntCount_DI0->Text = szBuf_IDI[2];
        editIntCount_DI1->Text = szBuf_IDI[3];

	m_ulDevNum = 0;
	DRV_SelectDevice( Handle, FALSE, &m_ulDevNum, DeviceName );
	editDevName->Text = DeviceName;
	scrollChanSpin->Position = 0;
	m_ErrCde = DRV_DeviceOpen( m_ulDevNum, &m_DriverHandle );
	if ( m_ErrCde != SUCCESS )
        {
           DRV_GetErrorMessage(m_ErrCde, m_szErrMsg);
           MessageBox(Handle, m_szErrMsg, "Device Open", MB_OK);
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnSelDevClick(TObject *Sender)
{
	char DeviceName[50];

	if ( m_DriverHandle != NULL )
           DRV_DeviceClose( &m_DriverHandle );
	DRV_SelectDevice( Handle, FALSE, &m_ulDevNum, DeviceName );
	editDevName->Text = DeviceName;
	m_ErrCde = DRV_DeviceOpen( m_ulDevNum, &m_DriverHandle);        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::scrollChanSpinChange(TObject *Sender)
{
        editChan->Text =  IntToStr(scrollChanSpin->Position);       
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnStartClick(TObject *Sender)
{
        m_StartFlag = 1;
        Timer1->Enabled = TRUE;
        Timer1->Interval = StrToInt(editScanTime->Text);
	btnStart->Enabled = FALSE;
        btnStop->Enabled = TRUE;
        btnSelDev->Enabled = FALSE;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnStopClick(TObject *Sender)
{
	Timer1->Enabled = FALSE;
        m_StartFlag = 0;
        btnStart->Enabled = TRUE;
        btnStop->Enabled = FALSE;
        if ( !(m_bDI0Flag || m_bDI1Flag || m_bIDI1Flag || m_bIDI0Flag || m_StartFlag ))
        {
           btnSelDev->Enabled = TRUE;
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Timer1Timer(TObject *Sender)
{
	USHORT	gwValue;		// input value
	char	szBuf[10];

	m_ptDioReadPortByte.port = StrToInt(editChan->Text);
	m_ptDioReadPortByte.value = (USHORT far *)&gwValue;

	if ((m_ErrCde = DRV_DioReadPortByte(m_DriverHandle,
                (LPT_DioReadPortByte)&m_ptDioReadPortByte)) != 0)
	{
	   DRV_GetErrorMessage(m_ErrCde,(LPSTR)m_szErrMsg);
	   Timer1->Enabled = FALSE;
	   MessageBox(Handle, (LPCSTR)m_szErrMsg, "Driver Message", MB_OK);
	} 
	else 
	{
	   sprintf( szBuf, "%02X", gwValue );
	   editScanData->Text = szBuf;
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnEnable1Click(TObject *Sender)
{
	PT_EnableEvent	EventSetting;

        m_bIDI0Flag   = TRUE;
        usStartFlag  = 1;
        EventSetting.Enabled   = TRUE;
        EventSetting.Count     = StrToInt(editCount_IDI0->Text);

        EventSetting.EventType = ADS_EVT_INTERRUPT_IDI0;
        m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );
        if ( m_ErrCde != 0)
        {
           DRV_GetErrorMessage( m_ErrCde, (LPSTR)m_szErrMsg );
           MessageBox(Handle, (LPCSTR)m_szErrMsg, "Driver Message", MB_OK );
           return;
        }

        btnDisable1->Enabled = TRUE;
        btnEnable1->Enabled = FALSE;
        btnSelDev->Enabled = FALSE;

        if ( m_bFlag == FALSE )
        {
           m_bContinue = TRUE;

           // Using THREAD_PRIORITY_TIME_CRITICAL for interrupt event handling routine,
           // you can get about 20 KHz response ratio by using PENTIUM 200 MMX PC.
           pEventThread = new EventThread(true);
           pEventThread->Priority = tpTimeCritical;
           pEventThread->Resume();
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnEnable2Click(TObject *Sender)
{
	PT_EnableEvent	EventSetting;

        m_bIDI1Flag   = TRUE;
        usStartFlag  = 1;
        EventSetting.Enabled   = TRUE;
        EventSetting.Count     = StrToInt(editCount_IDI1->Text);

        EventSetting.EventType = ADS_EVT_INTERRUPT_IDI1;
        m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );
        if ( m_ErrCde != 0)
        {
           DRV_GetErrorMessage( m_ErrCde, (LPSTR)m_szErrMsg );
           MessageBox(Handle, (LPCSTR)m_szErrMsg, "Driver Message", MB_OK );
           return;
        }

        btnDisable2->Enabled = TRUE;
        btnEnable2->Enabled = FALSE;
        btnSelDev->Enabled = FALSE;

        if ( m_bFlag == FALSE )
        {
           m_bContinue = TRUE;

           // Using THREAD_PRIORITY_TIME_CRITICAL for interrupt event handling routine,
           // you can get about 20 KHz response ratio by using PENTIUM 200 MMX PC.
           pEventThread = new EventThread(true);
           pEventThread->Priority = tpTimeCritical;
           pEventThread->Resume();
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnEnable3Click(TObject *Sender)
{
	PT_EnableEvent	EventSetting;

        m_bDI0Flag   = TRUE;
        usStartFlag  = 1;
        EventSetting.Enabled   = TRUE;
        EventSetting.Count     = StrToInt(editCount_DI0->Text);

        EventSetting.EventType = ADS_EVT_INTERRUPT_IDI16;
        m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );
        if ( m_ErrCde != 0)
        {
           DRV_GetErrorMessage( m_ErrCde, (LPSTR)m_szErrMsg );
           MessageBox(Handle, (LPCSTR)m_szErrMsg, "Driver Message", MB_OK );
           return;
        }

        btnDisable3->Enabled = TRUE;
        btnEnable3->Enabled = FALSE;
        btnSelDev->Enabled = FALSE;

        if ( m_bFlag == FALSE )
        {
           m_bContinue = TRUE;

           // Using THREAD_PRIORITY_TIME_CRITICAL for interrupt event handling routine,
           // you can get about 20 KHz response ratio by using PENTIUM 200 MMX PC.
           pEventThread = new EventThread(true);
           pEventThread->Priority = tpTimeCritical;
           pEventThread->Resume();
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnEnable4Click(TObject *Sender)
{
	PT_EnableEvent	EventSetting;

        m_bDI1Flag   = TRUE;
        usStartFlag  = 1;
        EventSetting.Enabled   = TRUE;
        EventSetting.Count     = StrToInt(editCount_DI1->Text);

        EventSetting.EventType = ADS_EVT_INTERRUPT_IDI17;
        m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );
        if ( m_ErrCde != 0)
        {
           DRV_GetErrorMessage( m_ErrCde, (LPSTR)m_szErrMsg );
           MessageBox(Handle, (LPCSTR)m_szErrMsg, "Driver Message", MB_OK );
           return;
        }

        btnDisable4->Enabled = TRUE;
        btnEnable4->Enabled = FALSE;
        btnSelDev->Enabled = FALSE;

        if ( m_bFlag == FALSE )
        {
           m_bContinue = TRUE;

           // Using THREAD_PRIORITY_TIME_CRITICAL for interrupt event handling routine,
           // you can get about 20 KHz response ratio by using PENTIUM 200 MMX PC.
           pEventThread = new EventThread(true);
           pEventThread->Priority = tpTimeCritical;
           pEventThread->Resume();
        }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnDisable1Click(TObject *Sender)
{
	PT_EnableEvent	EventSetting;
	BOOL            flag = FALSE;

        m_bIDI0Flag = FALSE;

	if ( !(m_bDI0Flag || m_bDI1Flag || m_bIDI0Flag || m_bIDI1Flag ))
	{
	   m_bContinue = FALSE;
	   m_bFlag = FALSE;
           if ( !m_StartFlag )
           {
              btnSelDev->Enabled = TRUE;
           }
        }
        usStartFlag = 0;
	while ( !flag )
	{
           btnDisable1->Enabled = FALSE;
           btnEnable1->Enabled = TRUE;

           EventSetting.EventType = ADS_EVT_INTERRUPT_IDI0;
           EventSetting.Enabled   = FALSE;
           m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );

           if ( m_ErrCde != 0 )
           {
              DRV_GetErrorMessage( m_ErrCde, (LPSTR)m_szErrMsg );
 	      MessageBox(Handle, (LPCSTR)m_szErrMsg, "Driver Message", MB_OK );
	      return;
           }
           flag = TRUE;
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnDisable2Click(TObject *Sender)
{
	PT_EnableEvent	EventSetting;
	BOOL            flag = FALSE;

        m_bIDI1Flag = FALSE;

	if ( !(m_bDI0Flag || m_bDI1Flag || m_bIDI0Flag || m_bIDI1Flag ))
	{
	   m_bContinue = FALSE;
	   m_bFlag = FALSE;
           if ( !m_StartFlag )
           {
              btnSelDev->Enabled = TRUE;
           }
        }
        usStartFlag = 0;
	while ( !flag )
	{
           btnDisable2->Enabled = FALSE;
           btnEnable2->Enabled = TRUE;

           EventSetting.EventType = ADS_EVT_INTERRUPT_IDI1;
           EventSetting.Enabled   = FALSE;
           m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );

           if ( m_ErrCde != 0 )
           {
              DRV_GetErrorMessage( m_ErrCde, (LPSTR)m_szErrMsg );
 	      MessageBox(Handle, (LPCSTR)m_szErrMsg, "Driver Message", MB_OK );
	      return;
           }
           flag = TRUE;
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnDisable3Click(TObject *Sender)
{
	PT_EnableEvent	EventSetting;
	BOOL            flag = FALSE;

        m_bDI0Flag = FALSE;

	if ( !(m_bDI0Flag || m_bDI1Flag || m_bIDI0Flag || m_bIDI1Flag ))
	{
	   m_bContinue = FALSE;
	   m_bFlag = FALSE;
           if ( !m_StartFlag )
           {
              btnSelDev->Enabled = TRUE;
           }
        }
        usStartFlag = 0;
	while ( !flag )
	{
           btnDisable3->Enabled = FALSE;
           btnEnable3->Enabled = TRUE;

           EventSetting.EventType = ADS_EVT_INTERRUPT_IDI16;
           EventSetting.Enabled   = FALSE;
           m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );

           if ( m_ErrCde != 0 )
           {
              DRV_GetErrorMessage( m_ErrCde, (LPSTR)m_szErrMsg );
 	      MessageBox(Handle, (LPCSTR)m_szErrMsg, "Driver Message", MB_OK );
	      return;
           }
           flag = TRUE;
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnDisable4Click(TObject *Sender)
{
	PT_EnableEvent	EventSetting;
	BOOL            flag = FALSE;

        m_bDI1Flag = FALSE;

	if ( !(m_bDI0Flag || m_bDI1Flag || m_bIDI0Flag || m_bIDI1Flag ))
	{
	   m_bContinue = FALSE;
	   m_bFlag = FALSE;
           if ( !m_StartFlag )
           {
              btnSelDev->Enabled = TRUE;
           }
        }
        usStartFlag = 0;
	while ( !flag )
	{
           btnDisable4->Enabled = FALSE;
           btnEnable4->Enabled = TRUE;

           EventSetting.EventType = ADS_EVT_INTERRUPT_IDI17;
           EventSetting.Enabled   = FALSE;
           m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );

           if ( m_ErrCde != 0 )
           {
              DRV_GetErrorMessage( m_ErrCde, (LPSTR)m_szErrMsg );
 	      MessageBox(Handle, (LPCSTR)m_szErrMsg, "Driver Message", MB_OK );
	      return;
           }
           flag = TRUE;
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnCloseClick(TObject *Sender)
{
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	m_bContinue = FALSE;
 	PT_EnableEvent	EventSetting;
        DWORD           ExitCode;

	if( usStartFlag == 1 )
	{
	   usStartFlag = 0;
           EventSetting.EventType = ADS_EVT_INTERRUPT_IDI0;
           EventSetting.Enabled   = FALSE;
           m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );

           EventSetting.EventType = ADS_EVT_INTERRUPT_IDI1;
           m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );
           EventSetting.EventType = ADS_EVT_INTERRUPT_IDI16;
           m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );
           EventSetting.EventType = ADS_EVT_INTERRUPT_IDI17;
           m_ErrCde = DRV_EnableEvent( m_DriverHandle, &EventSetting );
           if ( m_ErrCde != 0 )
           {
              DRV_GetErrorMessage( m_ErrCde, (LPSTR)m_szErrMsg );
 	      MessageBox(Handle, (LPCSTR)m_szErrMsg, "Driver Message", MB_OK );
	      return;
           }
	}


        if(pEventThread)
        {
             pEventThread->Terminate();
             GetExitCodeThread((void *)(pEventThread->Handle), &ExitCode);
             if(ExitCode==STILL_ACTIVE)
               TerminateThread((void *)(pEventThread->Handle), ExitCode);
             }


	Sleep(50L);
	if ( m_DriverHandle != NULL )
           DRV_DeviceClose( &m_DriverHandle );
}
//---------------------------------------------------------------------------

void TMainForm::CheckEvent()
{
        INT     i;
        DWORD	dwStartTime;
        DWORD	dwCurrentTime;
        DWORD	dwTime;
        float	fEventCount_IDI[4];
        float	ratio_IDI[ 4 ];
        char	szBuf_IDI[4][20];
        USHORT	usEventType;

        for ( i = 0; i < 4; i++ )
        {
           fEventCount_IDI[ i ] = 0.0;
        }

        ptCheckEvent.EventType = &usEventType;
        ptCheckEvent.Milliseconds = 1000;
        dwStartTime = GetTickCount();

        while ( m_bContinue )
        {
           m_bFlag = TRUE;
           if ( DRV_CheckEvent( m_DriverHandle, &ptCheckEvent ) == SUCCESS)
           {
              if ( *ptCheckEvent.EventType == ADS_EVT_INTERRUPT_IDI0 )
              {
                 fEventCount_IDI[ 0 ]++;
              }
              if ( *ptCheckEvent.EventType == ADS_EVT_INTERRUPT_IDI1 )
              {
                 fEventCount_IDI[ 1 ]++;
              }
              if ( *ptCheckEvent.EventType == ADS_EVT_INTERRUPT_IDI16 )
              {
                 fEventCount_IDI[ 2 ]++;
              }
              if ( *ptCheckEvent.EventType == ADS_EVT_INTERRUPT_IDI17 )
              {
                 fEventCount_IDI[ 3 ]++;
              }
           }

           dwCurrentTime = GetTickCount();
           if ( ( dwTime = dwCurrentTime - dwStartTime ) >= 1000 )
           {
              for ( i = 0; i < 4; i++ )
              {
                 ratio_IDI[i] = ((fEventCount_IDI[i] / (float)dwTime) * 1000.0);
                 sprintf( szBuf_IDI[i], "%.3f", ratio_IDI[i] );
                 fEventCount_IDI[i] = 0.0;
              }

              editIntCount_IDI0->Text = szBuf_IDI[0];
              editIntCount_IDI1->Text = szBuf_IDI[1];
              editIntCount_DI0->Text = szBuf_IDI[2];
              editIntCount_DI1->Text = szBuf_IDI[3];

              dwStartTime = GetTickCount();
           }
        }


}


//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall EventThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall EventThread::EventThread(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall EventThread::Execute()
{
        //---- Place thread code here ----
        MainForm->CheckEvent();
}
//---------------------------------------------------------------------------

