//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DiginExForm.h"
#include "../../../include/driver.h"
#include "CounterForm.h"
#include "FilterForm.h"
#include "PatternForm.h"
#include "StatusForm.h"
#include "EventThread.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
//the static varible for this program
static ULONG       lDeviceNum;

static PT_EnableEventEx        ptEnableEventEx;     // Enable event
static PT_FAICheck             ptFAICheck;          // FAICheck table
static PT_FDITransfer          ptFDITransfer;
static PT_DioReadPortByte      ptDioReadPortByte;

LONG        lDriverHandle;
PT_CheckEvent           ptCheckEvent;        // Check event

EventThread *myEventThread;                  //Thread object
BOOL bThreadRun;

LRESULT     ErrCde;
char        szErrMsg[80];

USHORT      usFHiValue[8]={0,0,0,0,0,0,0,0}, usFLowValue[8]={0,0,0,0,0,0,0,0}, usFEnable = 0;
USHORT      usPEnable = 0, usPValue = 0;
USHORT      usSEnable = 0, usSRiseEdge = 0, usSFallEdge =0;
USHORT      usCPreset[8] = {0,0,0,0,0,0,0,0}, usCMatchValue[8] = {0,0,0,0,0,0,0,0};
USHORT      usCEnable=0, usCMatchEnable=0, usTrigEdge=0, usCOverflow=0;

//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
    bFilter = False;
    bCounter = False;
    bPattern = False;
    bStatus = False;
    usCMCount = 0;
    usCOCount =0;
    usFSCount =0;
    usPCount = 0;
    usRSCount = 0;
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
    char *szDescription;
    szDescription = new char[80];
    if(1 == DRV_SelectDevice(Handle, True, (ULONG*)&lDeviceNum, szDescription)){
        Application->MessageBoxA("Can not Open Select Device Dialog", "Error");
        delete szDescription;
        btnExitClick(Sender);
    }
    labDeviceName->Caption = AnsiString(szDescription);
    delete szDescription;

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnExitClick(TObject *Sender)
{
    Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnSelectDeviceClick(TObject *Sender)
{
    char *szDescription;
    szDescription = new char[80];
    if(1 == DRV_SelectDevice(Handle, True, (ULONG*)&lDeviceNum, szDescription)){
        Application->MessageBoxA("Can not Open Select Device Dialog", "Error");
        delete szDescription;
        btnExitClick(Sender);
    }
    labDeviceName->Caption = AnsiString(szDescription);
    delete szDescription;
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::chkFilterClick(TObject *Sender)
{
    if(chkFilter->Checked){
        frmFilter->ShowModal();
        bFilter = True;
    }else{
        bFilter = False;
    }
        
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::chkPatternClick(TObject *Sender)
{
    if(chkPattern->Checked){
        frmPattern->ShowModal();
        bPattern = True;
    }else{
        bPattern = False;
    }
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::chkCounterClick(TObject *Sender)
{
    if(chkCounter->Checked){
        frmCounter->ShowModal();
        bCounter = True;
    }else{
        bCounter = False;
    }
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::chkStatusClick(TObject *Sender)
{
    if(chkStatus->Checked){
        frmStatus->ShowModal();
        bStatus = True;
    }else{
        bStatus = False;
    }
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::btnStartClick(TObject *Sender)
{

    if((!bFilter)&&(!bCounter)&&(!bPattern)&&(!bStatus)){
        Application->MessageBoxA("Please select the event first", "Warning");
        return;
    }
    ErrCde = DRV_DeviceOpen(lDeviceNum,(LONG far*)&lDriverHandle);
    if(ErrCde != SUCCESS){
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
        return;
    }

    //set filter event
    if(bFilter){
        ptEnableEventEx.Filter.usEventType = ADS_EVT_FILTER;
        ptEnableEventEx.Filter.usEventEnable = True;
        ptEnableEventEx.Filter.usCount = 1;
        ptEnableEventEx.Filter.usEnable = usFEnable;
        ptEnableEventEx.Filter.usHiValue = usFHiValue;
        ptEnableEventEx.Filter.usLowValue = usFLowValue;

        ErrCde = DRV_EnableEventEx(lDriverHandle,(LPT_EnableEventEx)&ptEnableEventEx);
        if(ErrCde != SUCCESS){
            DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
            Application->MessageBoxA((char* )szErrMsg,"Driver Message");
            DRV_DeviceClose((LONG far *)&lDriverHandle);
            return;
        }
    }

    //set pattern event
    if(bPattern){
        ptEnableEventEx.Pattern.usEventType = ADS_EVT_PATTERNMATCH;
        ptEnableEventEx.Pattern.usEventEnable = True;
        ptEnableEventEx.Pattern.usCount = 1;
        ptEnableEventEx.Pattern.usEnable = usPEnable;
        ptEnableEventEx.Pattern.usValue = usPValue;

        ErrCde = DRV_EnableEventEx(lDriverHandle,(LPT_EnableEventEx)&ptEnableEventEx);
        if(ErrCde != SUCCESS){
            DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
            Application->MessageBoxA((char* )szErrMsg,"Driver Message");
            DRV_DeviceClose((LONG far *)&lDriverHandle);
            return;
        }
    }

    //set counter event
    if(bCounter){
        ptEnableEventEx.Counter.usEventType = ADS_EVT_COUNTER;
        ptEnableEventEx.Counter.usEventEnable = True;
        ptEnableEventEx.Counter.usCount = 1;
        ptEnableEventEx.Counter.usEnable = usCEnable;
        ptEnableEventEx.Counter.usTrigEdge = usTrigEdge;
        ptEnableEventEx.Counter.usPreset = usCPreset;
        ptEnableEventEx.Counter.usMatchEnable = usCMatchEnable;
        ptEnableEventEx.Counter.usValue = usCMatchValue;
        ptEnableEventEx.Counter.usOverflow = usCOverflow;
        ptEnableEventEx.Counter.usDirection = 0;

        ErrCde = DRV_EnableEventEx(lDriverHandle,(LPT_EnableEventEx)&ptEnableEventEx);
        if(ErrCde != SUCCESS){
            DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
            Application->MessageBoxA((char* )szErrMsg,"Driver Message");
            DRV_DeviceClose((LONG far *)&lDriverHandle);
            return;
        }
    }

    //set status event
    if(bStatus){
        ptEnableEventEx.Status.usEventType = ADS_EVT_STATUSCHANGE;
        ptEnableEventEx.Status.usEventEnable = True;
        ptEnableEventEx.Status.usCount   = 1;
	ptEnableEventEx.Status.usEnable = usSEnable;
	ptEnableEventEx.Status.usRisingedge = usSRiseEdge;
	ptEnableEventEx.Status.usFallingedge = usSFallEdge;
        ErrCde = DRV_EnableEventEx(lDriverHandle,(LPT_EnableEventEx)&ptEnableEventEx);
        if(ErrCde != SUCCESS){
            DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
            Application->MessageBoxA((char* )szErrMsg,"Driver Message");
            DRV_DeviceClose((LONG far *)&lDriverHandle);
            return;
        }
    }

    if(bPattern || bCounter || bStatus){
        //create and start the thread
        myEventThread = new EventThread(false);
        bThreadRun = True;
        ScanTimer->Interval = txtScanTime->Text.ToDouble();
        ScanTimer->Enabled = True;
    }
    btnStart->Enabled = False;
    btnExit->Enabled = False;
    btnStop->Enabled = True;
    grpDevName->Enabled = False;
    grpEventType->Enabled = False;
    
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::ScanTimerTimer(TObject *Sender)
{
    USHORT usInputData;
    ptDioReadPortByte.port = txtChannelNo->Text.ToInt();
    ptDioReadPortByte.value = &usInputData;
    ErrCde = DRV_DioReadPortByte(lDriverHandle,(LPT_DioReadPortByte)&ptDioReadPortByte);
    if(ErrCde != SUCCESS){
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBoxA((char* )szErrMsg,"Driver Message");
        ScanTimer->Enabled = False;
        return;
    }
    labValue->Caption = AnsiString(usInputData);

}
//---------------------------------------------------------------------------




void TfrmMain::adPatternMatchEvent()
{
        //TODO: Add your source code here
    ULONG retValue;
    ptFDITransfer.usEventType = ADS_EVT_PATTERNMATCH;
    ptFDITransfer.ulRetData = (ULONG far*)&retValue;

    if ((ErrCde = DRV_FDITransfer(lDriverHandle,
        (LPT_FDITransfer)&ptFDITransfer)) != SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBoxA((char*)szErrMsg,"Event Message");
        return ;
    }

    usPCount++;
    labPatternMatchCount->Caption = AnsiString(usPCount);

}

void TfrmMain::adCounterMatchEvent()
{
        //TODO: Add your source code here
    ULONG  retValue;

    ptFDITransfer.usEventType = ADS_EVT_COUNTERMATCH;
	ptFDITransfer.ulRetData = (ULONG far*)&retValue;

    if ((ErrCde = DRV_FDITransfer(lDriverHandle,
        (LPT_FDITransfer)&ptFDITransfer)) != SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBoxA((char*)szErrMsg,"Event Message");
        return ;
    }
    usCMCount++;
    labMatchChannel->Caption = AnsiString(retValue);
    labMatchCount->Caption = AnsiString(usCMCount);

    return;
}

void TfrmMain::adCounterOverflowEvent()
{
        //TODO: Add your source code here
    ULONG  retValue;

    ptFDITransfer.usEventType = ADS_EVT_COUNTEROVERFLOW;
	ptFDITransfer.ulRetData = &retValue;

    if ((ErrCde = DRV_FDITransfer(lDriverHandle,
        (LPT_FDITransfer)&ptFDITransfer)) != 0)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBoxA((char*)szErrMsg,"Event Message");
        return ;
    }

   usCOCount++;
   labOverflowChannel->Caption = AnsiString(retValue);
   labOverflowCount->Caption = AnsiString(usCOCount);
    return;
}

void TfrmMain::adStatusChangeEvent()
{
        //TODO: Add your source code here
    ULONG    retValue;

    ptFDITransfer.usEventType = ADS_EVT_STATUSCHANGE;
	ptFDITransfer.ulRetData = (ULONG far *)&retValue;

    if ((ErrCde = DRV_FDITransfer(lDriverHandle,
        (LPT_FDITransfer)&ptFDITransfer)) != 0)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBoxA((char* )szErrMsg,"Event Message");
        return ;
    }

    if (retValue & 0x0ff){
        usFSCount++;
        labStatus->Caption = AnsiString("Falling");
        labChannelNo->Caption = AnsiString(retValue&0x0ff);
        labStatusCount->Caption = AnsiString(usFSCount);
    }else if (retValue & 0x0ff00){
    	usRSCount++;
        labStatus->Caption = AnsiString("Rising");
        labChannelNo->Caption = AnsiString(retValue>>8);
        labStatusCount->Caption = AnsiString(usRSCount);
    }
    return;
}
void __fastcall TfrmMain::btnStopClick(TObject *Sender)
{
    PT_EnableEventEx      Zero = {0};

    myEventThread->Terminate();   //Terminate the Thread

    while(bThreadRun){
     //wait until the Thread is terminated successfully
    }
    Sleep(10);
    
    ptEnableEventEx = Zero;  //clear event

    if ((ErrCde = DRV_EnableEventEx(lDriverHandle,
        (LPT_EnableEventEx)&ptEnableEventEx)) != SUCCESS)
    {
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBoxA((char*)szErrMsg,"Driver Message");
        DRV_DeviceClose((LONG far *)&lDriverHandle);
        return;
     }
        DRV_DeviceClose((LONG far *)&lDriverHandle);
        delete myEventThread;
        btnStart->Enabled = True;
        btnExit->Enabled = True;
        btnStop->Enabled = False;
        grpDevName->Enabled = True;
        grpEventType->Enabled = True;
        ScanTimer->Enabled = False;
}
//---------------------------------------------------------------------------



void __fastcall TfrmMain::FormClose(TObject *Sender, TCloseAction &Action)
{
    if(bThreadRun==True){
        btnStopClick(Sender);
    }        
}
//---------------------------------------------------------------------------

