//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DisForm.h"
#include "MainForm.h"
#include "..\..\..\include\driver.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmDisplay *frmDisplay;

extern  PT_TCMuxRead    ptTCMuxRead;
extern  LONG   DeviceHandle;                  //Driver handle



//---------------------------------------------------------------------------
__fastcall TfrmDisplay::TfrmDisplay(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmDisplay::tmrReadTimer(TObject *Sender)
{

 int ErrCde;

   float fTemp;
    if( lstTemperatureUnit->ItemIndex >= 0 )
       ptTCMuxRead.TempScale = lstTemperatureUnit->ItemIndex;
    else
       ptTCMuxRead.TempScale = 0;
    ptTCMuxRead.temp = &fTemp;

    ErrCde = DRV_TCMuxRead(DeviceHandle, &ptTCMuxRead);

    if (ErrCde != 0)
    {
        char  szErrMsg[80];
        CmdExitClick(NULL);
        DRV_GetErrorMessage(ErrCde, szErrMsg);
        Application->MessageBox(szErrMsg, "Error!!", MB_OK);
        return ;
    }



    txtVoltRead->Text = FloatToStrF(fTemp, ffFixed, 5, 2);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDisplay::CmdExitClick(TObject *Sender)
{

    tmrRead->Enabled=false;
    Close();
    frmMain->Show();
}
//---------------------------------------------------------------------------
void __fastcall TfrmDisplay::FormCreate(TObject *Sender)
{
     hscrFreq->Position = 10;
     tmrRead->Enabled = False;
     //{ Add selectable items for temperature unit }
     lstTemperatureUnit->Items->Add("Celsius");
     lstTemperatureUnit->Items->Add("Fahrenheit");
     lstTemperatureUnit->Items->Add("Rankine");
     lstTemperatureUnit->Items->Add("Kelvin");

}
//---------------------------------------------------------------------------
void __fastcall TfrmDisplay::cmdReadClick(TObject *Sender)
{
   float fTemp;
    if( lstTemperatureUnit->ItemIndex >= 0 )
       ptTCMuxRead.TempScale = lstTemperatureUnit->ItemIndex;
    else
       ptTCMuxRead.TempScale = 0;
    ptTCMuxRead.temp = &fTemp;

   int  ErrCde = DRV_TCMuxRead(DeviceHandle, &ptTCMuxRead);
   if (ErrCde != 0)
    {
        char  szErrMsg[80];
        CmdExitClick(NULL);
        DRV_GetErrorMessage(ErrCde, szErrMsg);
        Application->MessageBox(szErrMsg, "Error!!", MB_OK);
        return ;
    }

    txtVoltRead->Text = FloatToStrF(fTemp, ffFixed, 5, 2);
}
//---------------------------------------------------------------------------
void __fastcall TfrmDisplay::hscrFreqChange(TObject *Sender)
{
     if( hscrFreq->Position == 0)
        tmrRead->Interval = 0 ;
     else
        tmrRead->Interval = (10000 / hscrFreq->Position);
     tmrRead->Enabled = True;

}
//---------------------------------------------------------------------------
void __fastcall TfrmDisplay::FormClose(TObject *Sender,
      TCloseAction &Action)
{
        DRV_DeviceClose(&DeviceHandle);
}
//---------------------------------------------------------------------------
