unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Driver, Thread, event, paras;

type
  TfrmMain = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    txtDeviceName: TEdit;
    cmdSelectDevice: TButton;
    chkFDiPatternMatch: TCheckBox;
    chkTimer: TCheckBox;
    chkStatusChange: TCheckBox;
    txtPatternMatchEvent: TEdit;
    txtCounterEvent: TEdit;
    txtStatusChangeEvent: TEdit;
    txtPatternMatchValue: TEdit;
    txtCounterValue: TEdit;
    txtChangeStatusChannel: TEdit;
    grpDiInterrupt: TGroupBox;
    GroupBox1: TGroupBox;
    lstDiSignalCondition7: TListBox;
    lstDiSignalCondition6: TListBox;
    lstDiSignalCondition5: TListBox;
    lstDiSignalCondition4: TListBox;
    lstDiSignalCondition3: TListBox;
    lstDiSignalCondition2: TListBox;
    lstDiSignalCondition1: TListBox;
    lstDiSignalCondition0: TListBox;
    ListBox9: TListBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    chkDiInterrupt0: TCheckBox;
    chkDiInterrupt1: TCheckBox;
    chkDiInterrupt2: TCheckBox;
    chkDiInterrupt3: TCheckBox;
    chkDiInterrupt4: TCheckBox;
    chkDiInterrupt5: TCheckBox;
    chkDiInterrupt6: TCheckBox;
    chkDiInterrupt7: TCheckBox;
    txtDiInterrupt1: TEdit;
    txtDiInterrupt2: TEdit;
    txtDiInterrupt3: TEdit;
    txtDiInterrupt0: TEdit;
    txtDiInterrupt4: TEdit;
    txtDiInterrupt5: TEdit;
    txtDiInterrupt6: TEdit;
    txtDiInterrupt7: TEdit;
    cmdStart: TButton;
    cmdStop: TButton;
    cmdExit: TButton;
    procedure cmdSelectDeviceClick(Sender: TObject);
    procedure cmdStartClick(Sender: TObject);
    procedure cmdStopClick(Sender: TObject);
    procedure EnableControls(bEnabled : boolean );
    procedure cmdExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure chkDiInterrupt0Click(Sender: TObject);
    procedure chkDiInterrupt1Click(Sender: TObject);
    procedure chkDiInterrupt2Click(Sender: TObject);
    procedure chkDiInterrupt3Click(Sender: TObject);
    procedure chkDiInterrupt4Click(Sender: TObject);
    procedure chkDiInterrupt5Click(Sender: TObject);
    procedure chkDiInterrupt6Click(Sender: TObject);
    procedure chkDiInterrupt7Click(Sender: TObject);
    procedure chkFDiPatternMatchClick(Sender: TObject);
    procedure chkTimerClick(Sender: TObject);
    procedure chkStatusChangeClick(Sender: TObject);
    procedure txtPatternMatchValueChange(Sender: TObject);
    procedure txtPatternMatchValueKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure lstDiSignalCondition7Click(Sender: TObject);
    procedure lstDiSignalCondition6Click(Sender: TObject);
    procedure lstDiSignalCondition5Click(Sender: TObject);
    procedure lstDiSignalCondition4Click(Sender: TObject);
    procedure lstDiSignalCondition3Click(Sender: TObject);
    procedure lstDiSignalCondition2Click(Sender: TObject);
    procedure lstDiSignalCondition1Click(Sender: TObject);
    procedure lstDiSignalCondition0Click(Sender: TObject);
    procedure txtCounterValueChange(Sender: TObject);
    procedure txtChangeStatusChannelChange(Sender: TObject);
    procedure CheckEvent();

  private
    { Private declarations }
  public
    { Public declarations }
        lstDiSignalCondition : array[0..8] of TListBox;
        chkDiInterrupt : array[0..8] of TCheckBox;
        txtDiInterrupt : array[0..8] of TEdit;
	m_DeviceHandle : LongInt;
	m_DeviceNum : integer;
	bThreadloop : Boolean;
	m_ErrCde : LongInt;                     // Return error code
	m_CounterValue : array[0..3] of DWORD;
	m_MatchValue : DWORD;
	m_DITriggerMode : LongInt;
	szErrMsg : Array[0..80] of char;
	m_StatusChannel : DWORD;
	m_DI0Count : DWORD;
	m_DI1Count : DWORD;
	m_DI2Count : DWORD;
	m_DI3Count : DWORD;
	m_DI4Count : DWORD;
	m_DI5Count : DWORD;
	m_DI6Count : DWORD;
	m_DI7Count : DWORD;
	m_MatchCount : DWORD;
	m_StatusCount : DWORD;
	m_TimerCount : DWORD;
        m_BoardID : DWORD;
        Thread  : TCheckThread;
        ptEnableEvent : PT_EnableEvent;     // Enable event
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}
 Function DoesErr(var lErrCode: LongInt): integer;
var
  szErrMsg   : string[100];
  pszErrMsg  : PChar;
  iRet       : integer;
begin
  {Check the pressed error code}
  If (lErrCode <> 0) Then
  begin
    pszErrMsg := @szErrMsg;
    DRV_GetErrorMessage(lErrCode, pszErrMsg);
    iRet := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
    DoesErr := 1;
  end
  else
    DoesErr := 0;
end;
procedure TfrmMain.cmdSelectDeviceClick(Sender: TObject);
var
	DeviceName : Array[0..100] of char ;
	dwCount : Longint;
	ExitCode : DWORD;
        i : integer;
begin
        bThreadloop:=false;
	// TODO: Add your control notification handler code here
	if ( m_DeviceHandle<> 0 )   then
	begin
		if( Assigned(Thread)) then
		begin
		   GetExitCodeThread(Thread.Handle,ExitCode);
		   if(ExitCode=STILL_ACTIVE) then
			   TerminateThread(Thread.Handle,ExitCode);
		end;
		DRV_DeviceClose( m_DeviceHandle );
	end;

	DRV_SelectDevice( Handle, FALSE, m_DeviceNum, DeviceName );
	txtDeviceName.Text:=DeviceName;

	m_ErrCde := DRV_DeviceOpen( m_DeviceNum, m_DeviceHandle);
       if( DoesErr(m_ErrCde) = 1 ) then
          Exit;

	dwCount := sizeof(DWORD);
	//Get the Di status change channel
	m_ErrCde := DRV_DeviceGetProperty(m_DeviceHandle, CFG_BoardID, @m_BoardID, dwCount);
       if(BD_PCI1755 = m_BoardID) then
           EnableControls(true)
       else
       begin
           EnableControls(false);
           exit;
       end;

	//Get the Di status change channel
	m_ErrCde := DRV_DeviceGetProperty(m_DeviceHandle, CFG_IrqDiChangeStatusChannel, @m_StatusChannel, dwCount);
        txtChangeStatusChannel.Text := IntToStr(m_StatusChannel);
	//Get the Pattern match value
 	m_ErrCde := DRV_DeviceGetProperty(m_DeviceHandle, CFG_DiPatternMatchValue, @m_MatchValue, dwCount);
        txtPatternMatchValue.Text := IntToHex(m_MatchValue,4);
	//Get the Di channel trigger mode
	m_ErrCde := DRV_DeviceGetProperty(m_DeviceHandle, CFG_IrqDiTriggerSignals, @m_DITriggerMode, dwCount);
	//Get the counter2 value
	dwCount := sizeof(m_CounterValue);
	m_ErrCde := DRV_DeviceGetProperty(m_DeviceHandle, CFG_CounterCountValue, @(m_CounterValue[0]), dwCount);
	txtCounterValue.Text := IntToStr(m_CounterValue[2]);
       if( DoesErr(m_ErrCde) = 1 ) then
          Exit;

	for i:=0 to 7 do
              lstDiSignalCondition[i].ItemIndex :=(m_DITriggerMode shl i and 1);


end;

procedure TfrmMain.cmdStartClick(Sender: TObject);
var
  i: integer;
begin

  txtCounterEvent.Text := '0';
  txtPatternMatchEvent.Text := '0';
  txtStatusChangeEvent.Text := '0';
  for i := 0 to 7 do
    txtDiInterrupt[i].Text := '0';
      m_DI0Count := 0;
      m_DI1Count := 0;
      m_DI2Count := 0;
      m_DI3Count := 0;
      m_DI4Count := 0;
      m_DI5Count := 0;
      m_DI6Count := 0;
      m_DI7Count := 0;
      m_MatchCount := 0;
      m_StatusCount := 0;
      m_TimerCount := 0;


  //
  // Create thread to check events
  //
  bThreadloop:=true;
        Thread := TCheckThread.Create(false); 
  // User controls setting
  //
  cmdStop.Enabled := true;
  cmdExit.Enabled := false;
  cmdStart.Enabled := false;
  cmdSelectDevice.Enabled := false;
end;

procedure TfrmMain.cmdStopClick(Sender: TObject);
var
  ExitCode : DWORD;

begin
  bThreadloop:=false;
  if( Assigned(Thread)) then
  begin
     Thread.Terminate();
     GetExitCodeThread(Thread.Handle,ExitCode);
     if(ExitCode = STILL_ACTIVE)  then
             TerminateThread(Thread.Handle,ExitCode);

  end;
  cmdStop.Enabled := false;
  cmdExit.Enabled := true;
  cmdStart.Enabled := true;
  cmdSelectDevice.Enabled := true;
end;
procedure TfrmMain.EnableControls(bEnabled : boolean );
var
  i : integer;
begin
  chkTimer.Enabled := bEnabled;
  txtCounterEvent.Enabled := bEnabled;
  txtCounterValue.Enabled := bEnabled;

  // Pattern match interrupt event controls enable or disable
  chkFDiPatternMatch.Enabled := bEnabled;
  txtPatternMatchEvent.Enabled := bEnabled;
  txtPatternMatchValue.Enabled := bEnabled;

  // Status change interrupt event controls enable or disable
  chkStatusChange.Enabled := bEnabled;
  txtStatusChangeEvent.Enabled := bEnabled;
  txtChangeStatusChannel.Enabled := bEnabled;

  // Auxiliary DI interrupt event controls enable or disable
   for i := 0 to 7 do
   begin
      lstDiSignalCondition[i].Enabled := bEnabled;
      chkDiInterrupt[i].Enabled := bEnabled;
      txtDiInterrupt[i].Enabled := bEnabled;
    end;

  // Execution controls enable and disable
  cmdStart.Enabled := bEnabled;
  cmdStop.Enabled := False;
end;



procedure TfrmMain.cmdExitClick(Sender: TObject);
begin
   Close();
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  ExitCode : DWORD;
begin   
    bThreadloop:=false;
    if( Assigned(Thread)) then
    begin
       Thread.Terminate();
       GetExitCodeThread(Thread.Handle,ExitCode);
       if(ExitCode = STILL_ACTIVE)  then
               TerminateThread(Thread.Handle,ExitCode);
    end;
     cmdStop.Enabled := false;
end;

procedure TfrmMain.chkDiInterrupt0Click(Sender: TObject);
begin
    ptEnableEvent.Enabled := Smallint(chkDiInterrupt0.Checked );
    ptEnableEvent.EventType := ADS_EVT_INTERRUPT_DI0;
    ptEnableEvent.Count := 1;
    DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);
end;

procedure TfrmMain.chkDiInterrupt1Click(Sender: TObject);
begin
    ptEnableEvent.Enabled := Smallint(chkDiInterrupt1.Checked );
    ptEnableEvent.EventType := ADS_EVT_INTERRUPT_DI1;
    ptEnableEvent.Count := 1;
    DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);

end;

procedure TfrmMain.chkDiInterrupt2Click(Sender: TObject);
begin
    ptEnableEvent.Enabled := Smallint(chkDiInterrupt2.Checked );
    ptEnableEvent.EventType := ADS_EVT_INTERRUPT_DI2;
    ptEnableEvent.Count := 1;
    DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);

end;

procedure TfrmMain.chkDiInterrupt3Click(Sender: TObject);
begin
    ptEnableEvent.Enabled := Smallint(chkDiInterrupt3.Checked );
    ptEnableEvent.EventType := ADS_EVT_INTERRUPT_DI3;
    ptEnableEvent.Count := 1;
    DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);

end;

procedure TfrmMain.chkDiInterrupt4Click(Sender: TObject);
begin
    ptEnableEvent.Enabled := Smallint(chkDiInterrupt4.Checked );
    ptEnableEvent.EventType := ADS_EVT_INTERRUPT_DI4;
    ptEnableEvent.Count := 1;
    DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);

end;

procedure TfrmMain.chkDiInterrupt5Click(Sender: TObject);
begin
    ptEnableEvent.Enabled := Smallint(chkDiInterrupt5.Checked );
    ptEnableEvent.EventType := ADS_EVT_INTERRUPT_DI5;
    ptEnableEvent.Count := 1;
    DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);

end;

procedure TfrmMain.chkDiInterrupt6Click(Sender: TObject);
begin
    ptEnableEvent.Enabled := Smallint(chkDiInterrupt6.Checked );
    ptEnableEvent.EventType := ADS_EVT_INTERRUPT_DI6;
    ptEnableEvent.Count := 1;
    DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);

end;

procedure TfrmMain.chkDiInterrupt7Click(Sender: TObject);
begin
    ptEnableEvent.Enabled := Smallint(chkDiInterrupt7.Checked );
    ptEnableEvent.EventType := ADS_EVT_INTERRUPT_DI7;
    ptEnableEvent.Count := 1;
    DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);
end;

procedure TfrmMain.chkFDiPatternMatchClick(Sender: TObject);
begin
	//Get the Pattern match value
        m_MatchValue := StrToInt('0x'+txtPatternMatchValue.Text ) ;
 	m_ErrCde := DRV_DeviceSetProperty(m_DeviceHandle, CFG_DiPatternMatchValue, @m_MatchValue, 4);
 	ptEnableEvent.Enabled := Smallint(chkFDiPatternMatch.Checked);
	ptEnableEvent.EventType := ADS_EVT_DI_PATTERNMATCH;
	ptEnableEvent.Count := 1;
	DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);
	txtPatternMatchValue.Enabled := not chkFDiPatternMatch.Checked;
end;

procedure TfrmMain.chkTimerClick(Sender: TObject);
begin
	m_CounterValue[2] := StrToint(txtCounterValue.Text);
	m_ErrCde := DRV_DeviceSetProperty(m_DeviceHandle, CFG_CounterCountValue, @(m_CounterValue[0]), 12);

 	ptEnableEvent.Enabled := Smallint(chkTimer.Checked);
	ptEnableEvent.EventType := ADS_EVT_TC_TIMER;
	ptEnableEvent.Count := 1;
	DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);
	txtCounterValue.Enabled := not chkTimer.Checked;
end;

procedure TfrmMain.chkStatusChangeClick(Sender: TObject);
begin
	//Get the Di status change channel
        m_StatusChannel := StrToint(txtChangeStatusChannel.Text);
	m_ErrCde := DRV_DeviceSetProperty(m_DeviceHandle, CFG_IrqDiChangeStatusChannel,
         @m_StatusChannel, 4);
	ptEnableEvent.Enabled := Smallint(chkStatusChange.Checked);
	ptEnableEvent.EventType := ADS_EVT_DI_STATUSCHANGE;
	ptEnableEvent.Count := 1;
	DRV_EnableEvent(m_DeviceHandle,ptEnableEvent);
	txtChangeStatusChannel.Enabled := not chkStatusChange.Checked;
end;

procedure TfrmMain.txtPatternMatchValueChange(Sender: TObject);
var
    lStart : Longint;
    lLength : Longint;
   strHex : String;
begin

  //ound the Pattern Match value in 0 ~ FFFFFFFFh

  If (Length(txtPatternMatchValue.Text) > 8) Then
  begin
    //Out of value bound
    lStart := txtPatternMatchValue.SelStart;
    lLength := txtPatternMatchValue.SelLength;
    If lStart <> 0 Then lStart := lStart - 1;

    txtPatternMatchValue.Text := IntToHex(txtPatternMatchValue.Tag,8);
    
    txtPatternMatchValue.SelStart := lStart;
    txtPatternMatchValue.SelLength := lLength  ;
  end;
  
  If (Length(txtPatternMatchValue.Text) = 0) Then
  begin
    // 0 Value
    txtPatternMatchValue.Text := '0';
    txtPatternMatchValue.SelStart := 0;
  end;

  // Valid Patterm Match value,write this new property value to device.
  strHex := '$' + txtPatternMatchValue.Text;
  lStart := StrToInt(strHex);
  txtPatternMatchValue.Tag := lStart;
end;

procedure TfrmMain.txtPatternMatchValueKeyPress(Sender: TObject;
  var Key: Char);
var
  Asckey : BYTE;
  i      : Integer;

begin

  Asckey :=  BYTE(Key);



 If ((Asckey >= BYTE('0')) and (Asckey <= BYTE('9')) ) Then
    exit;

  If ( (Asckey >= BYTE('A')) And (Asckey <= BYTE('F')) ) Then
   exit;

  If ( (Asckey >= BYTE('a')) And (Asckey <= BYTE('f')) ) Then
  begin
      for i :=0 to (BYTE('a') - BYTE('A')-1) do
      begin
         Dec(Key);
      end;
       exit;
  end;


  Key := Low(Key);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  lstDiSignalCondition[0] := lstDiSignalCondition0;
  lstDiSignalCondition[1] := lstDiSignalCondition1;
  lstDiSignalCondition[2] := lstDiSignalCondition2;
  lstDiSignalCondition[3] := lstDiSignalCondition3;
  lstDiSignalCondition[4] := lstDiSignalCondition4;
  lstDiSignalCondition[5] := lstDiSignalCondition5;
  lstDiSignalCondition[6] := lstDiSignalCondition6;
  lstDiSignalCondition[7] := lstDiSignalCondition7;

  chkDiInterrupt[0] := chkDiInterrupt0;
  chkDiInterrupt[1] := chkDiInterrupt1;
  chkDiInterrupt[2] := chkDiInterrupt2;
  chkDiInterrupt[3] := chkDiInterrupt3;
  chkDiInterrupt[4] := chkDiInterrupt4;
  chkDiInterrupt[5] := chkDiInterrupt5;
  chkDiInterrupt[6] := chkDiInterrupt6;
  chkDiInterrupt[7] := chkDiInterrupt7;

  txtDiInterrupt[0] := txtDiInterrupt0;
  txtDiInterrupt[1] := txtDiInterrupt1;
  txtDiInterrupt[2] := txtDiInterrupt2;
  txtDiInterrupt[3] := txtDiInterrupt3;
  txtDiInterrupt[4] := txtDiInterrupt4;
  txtDiInterrupt[5] := txtDiInterrupt5;
  txtDiInterrupt[6] := txtDiInterrupt6;
  txtDiInterrupt[7] := txtDiInterrupt7;
  bThreadloop := true;

  cmdSelectDeviceClick(Sender);
end;

procedure TfrmMain.lstDiSignalCondition7Click(Sender: TObject);
var
  i      : Integer;
begin
      m_DITriggerMode := 0;
      for i := 0 to 7 do
              m_DITriggerMode := m_DITriggerMode or (lstDiSignalCondition[i].ItemIndex shl i);
      DRV_DeviceSetProperty(m_DeviceHandle, CFG_IrqDiTriggerSignals, @m_DITriggerMode, 4);
end;

procedure TfrmMain.lstDiSignalCondition6Click(Sender: TObject);
var
  i      : Integer;
begin
      m_DITriggerMode := 0;
      for i := 0 to 7 do
              m_DITriggerMode := m_DITriggerMode or (lstDiSignalCondition[i].ItemIndex shl i);
      DRV_DeviceSetProperty(m_DeviceHandle, CFG_IrqDiTriggerSignals, @m_DITriggerMode, 4);
end;

procedure TfrmMain.lstDiSignalCondition5Click(Sender: TObject);
var
  i      : Integer;
begin
      m_DITriggerMode := 0;
      for i := 0 to 7 do
              m_DITriggerMode := m_DITriggerMode or (lstDiSignalCondition[i].ItemIndex shl i);
      DRV_DeviceSetProperty(m_DeviceHandle, CFG_IrqDiTriggerSignals, @m_DITriggerMode, 4);
end;


procedure TfrmMain.lstDiSignalCondition4Click(Sender: TObject);
var
  i      : Integer;
begin
      m_DITriggerMode := 0;
      for i := 0 to 7 do
              m_DITriggerMode := m_DITriggerMode or (lstDiSignalCondition[i].ItemIndex shl i);
      DRV_DeviceSetProperty(m_DeviceHandle, CFG_IrqDiTriggerSignals, @m_DITriggerMode, 4);
end;


procedure TfrmMain.lstDiSignalCondition3Click(Sender: TObject);
var
  i      : Integer;
begin
      m_DITriggerMode := 0;
      for i := 0 to 7 do
              m_DITriggerMode := m_DITriggerMode or (lstDiSignalCondition[i].ItemIndex shl i);
      DRV_DeviceSetProperty(m_DeviceHandle, CFG_IrqDiTriggerSignals, @m_DITriggerMode, 4);
end;

procedure TfrmMain.lstDiSignalCondition2Click(Sender: TObject);
var
  i      : Integer;
begin
      m_DITriggerMode := 0;
      for i := 0 to 7 do
              m_DITriggerMode := m_DITriggerMode or (lstDiSignalCondition[i].ItemIndex shl i);
      DRV_DeviceSetProperty(m_DeviceHandle, CFG_IrqDiTriggerSignals, @m_DITriggerMode, 4);
end;

procedure TfrmMain.lstDiSignalCondition1Click(Sender: TObject);
var
  i      : Integer;
begin
      m_DITriggerMode := 0;
      for i := 0 to 7 do
              m_DITriggerMode := m_DITriggerMode or (lstDiSignalCondition[i].ItemIndex shl i);
      DRV_DeviceSetProperty(m_DeviceHandle, CFG_IrqDiTriggerSignals, @m_DITriggerMode, 4);
end;

procedure TfrmMain.lstDiSignalCondition0Click(Sender: TObject);
var
  i      : Integer;
begin
      m_DITriggerMode := 0;
      for i := 0 to 7 do
              m_DITriggerMode := m_DITriggerMode or (lstDiSignalCondition[i].ItemIndex shl i);
      DRV_DeviceSetProperty(m_DeviceHandle, CFG_IrqDiTriggerSignals, @m_DITriggerMode, 4);
end;

procedure TfrmMain.txtCounterValueChange(Sender: TObject);
var
    lStart : Longint;
    lLength : Longint;
begin
  //
  // Check value boundary and set counter 2 value to device.
  // Counter 2 is the timer interrupt source, base frequency on 10 Mhz.
  //


  lStart := txtCounterValue.SelStart;
  lLength := txtCounterValue.SelLength;
  
  //
  // Bound the input value between 2 ~ 65535.
  //
  if(Length(txtCounterValue.Text)=0 ) then
  begin
   txtCounterValue.Text := '2';
  end;

  if(StrToInt(txtCounterValue.Text) < 2)  then
  begin
    txtCounterValue.Text := '2';
    txtCounterValue.SelStart := 0;
    txtCounterValue.SelLength := 5;
  end
  else if(StrToInt(txtCounterValue.Text) > 65535)  then
  begin
    if(lStart <> 0) then
      lStart := lStart-1;

    txtCounterValue.Text := IntToStr(txtCounterValue.Tag);
    txtCounterValue.SelStart := lStart;
    txtCounterValue.SelLength := lLength;
  end
  else
  begin
    //
    // Counter 2 value chaged, write new value to device.
    //
    txtCounterValue.Tag := StrToInt(txtCounterValue.Text);



    txtCounterValue.Text := IntToStr(txtCounterValue.Tag);
    txtCounterValue.SelStart := lStart;
    txtCounterValue.SelLength := lLength;
  end;

end;

procedure TfrmMain.txtChangeStatusChannelChange(Sender: TObject);
var
    lStart : Longint;
    lLength : Longint;
   lValue : LongInt;
begin

  // Change status channel setting.
  if(Length(txtChangeStatusChannel.Text)=0 ) then
  begin
   txtChangeStatusChannel.Text := '0';
  end;

  lValue := StrToInt(txtChangeStatusChannel.Text);
  
  If (lValue > 31) Then
  begin
    //Out of value bound, only support upto 31 DI channel
    lStart := txtChangeStatusChannel.SelStart;
    lLength := txtChangeStatusChannel.SelLength ;
    If lStart <> 0 Then lStart := lStart - 1;
    
    txtChangeStatusChannel.Text := IntToStr(txtChangeStatusChannel.Tag);
    
    txtChangeStatusChannel.SelStart := lStart;
    txtChangeStatusChannel.SelLength := lLength ;
    Exit;
  End;

  If (lValue = 0) Then
  begin
    // 0 Value
    txtChangeStatusChannel.Text := '0'  ;
    txtChangeStatusChannel.SelStart := 0 ;
  End ;
  
  // Write Change status channel property to device driver.
  txtChangeStatusChannel.Tag := lValue ;
end;


procedure TfrmMain.CheckEvent();
var
      ptCheckEvent :  PT_CheckEvent      ;      // Check event
      usEventTye : SmallInt;

begin
      ptCheckEvent.EventType:= @usEventTye;
      ptCheckEvent.Milliseconds := 500;

      while(bThreadloop)   do
      begin
              DRV_CheckEvent(m_DeviceHandle, ptCheckEvent);

              case usEventTye of

              ADS_EVT_DI_PATTERNMATCH:
              begin
                      m_MatchCount := m_MatchCount+1;
                      txtPatternMatchEvent.Text := IntToStr(m_MatchCount);
               end;
              ADS_EVT_DI_STATUSCHANGE:
              begin
                      m_StatusCount := m_StatusCount+1;
                      txtStatusChangeEvent.Text := IntToStr(m_StatusCount);
               end;
             ADS_EVT_TC_TIMER:
              begin
                      m_TimerCount :=m_TimerCount+1;
                      txtCounterEvent.Text := IntToStr(m_TimerCount);
              end;
              ADS_EVT_INTERRUPT_DI0:
              begin
                      m_DI0Count :=m_DI0Count+1;
                      txtDiInterrupt0.Text := IntToStr(m_DI0Count);
              end;
              ADS_EVT_INTERRUPT_DI1:
              begin
                      m_DI1Count :=m_DI1Count+1;
                      txtDiInterrupt1.Text := IntToStr(m_DI1Count);
              end;
               ADS_EVT_INTERRUPT_DI2:
              begin
                      m_DI2Count :=m_DI2Count+1;
                      txtDiInterrupt2.Text := IntToStr(m_DI2Count);
               end;
             ADS_EVT_INTERRUPT_DI3:
              begin
                     m_DI3Count :=m_DI3Count+1;
                      txtDiInterrupt3.Text := IntToStr(m_DI3Count);
              end;
              ADS_EVT_INTERRUPT_DI4:
              begin
                      m_DI4Count :=m_DI4Count+1;
                      txtDiInterrupt4.Text := IntToStr(m_DI4Count);
              end;
              ADS_EVT_INTERRUPT_DI5:
              begin
                      m_DI5Count :=m_DI5Count+1;
                      txtDiInterrupt5.Text := IntToStr(m_DI5Count);
              end;
              ADS_EVT_INTERRUPT_DI6:
              begin
                      m_DI6Count :=m_DI6Count+1;
                      txtDiInterrupt6.Text := IntToStr(m_DI6Count);
              end;
              ADS_EVT_INTERRUPT_DI7:
              begin
                      m_DI7Count :=m_DI7Count+1;
                      txtDiInterrupt7.Text := IntToStr(m_DI7Count);
              end;
              else
              end;
      end;

end;
end.
