unit Formstar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Driver, Global, Menus;

type
  Tfrmstart = class(TForm)
    labSelDev: TLabel;
    labModule: TLabel;
    lstModule: TListBox;
    cmdRun: TButton;
    labChannel: TLabel;
    lstChannel: TListBox;
    cmdExit: TButton;
    lstDevice: TListBox;
    procedure cmdExitClick(Sender: TObject);
    procedure cmdRunClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lstDeviceClick(Sender: TObject);
    procedure lstModuleClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmstart: Tfrmstart;

implementation

uses formrun;

var
   lpDevFeatures      : DEVFEATURES;
   gnNumOfSubdevices  : Smallint;
   Response           : Integer;

{$R *.DFM}
procedure Tfrmstart.cmdExitClick(Sender: TObject);
begin
     if bRun then
        DRV_DeviceClose(DeviceHandle);
     close;
end;

procedure Tfrmstart.cmdRunClick(Sender: TObject);
begin
  lpDioPortMode.port := lstChannel.ItemIndex;
  if lpDioPortMode.port = -1 then
  begin
     lpDioPortMode.port := 0;
  end;
  
  lpDioPortMode.dir := OUTPORT;

  { not every digital I/O card could use DRV_DioSetPortMode function }
  if lpDevFeatures.usDIOPort > 0 then
  begin
     ErrCde := DRV_DioSetPortMode(DeviceHandle, lpDioPortMode);
     If (ErrCde <> 0) Then
     begin
          DRV_GetErrorMessage(ErrCde, pszErrMsg);
          Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
          Exit;
     end;
  end;
  FormRun.frmRun.ShowModal();
end;

procedure Tfrmstart.FormCreate(Sender: TObject);
var
  MaxEntries, OutEntries : Smallint;
  NumOfDevice            : Smallint;
  i, ii                  : Integer;
  tempStr                : String;
  testRes                : boolean;
begin
  bRun := False;

  { Add type of PC Laboratory Card }
  ErrCde := DRV_DeviceGetList(DeviceList[0], MaxEntries, OutEntries);
  If (ErrCde <> 0) Then
  begin
       DRV_GetErrorMessage(ErrCde, pszErrMsg);
       Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
       Exit;
  end;

  { Here NumOfDevice = OutEntries }
  ErrCde := DRV_DeviceGetNumOfList(MaxEntries);
  If (ErrCde <> 0) Then
  begin
       DRV_GetErrorMessage(ErrCde, pszErrMsg);
       Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
       Exit;
  end;

  For i := 0 To (MaxEntries - 1) do
  begin
    tempStr := '';
    For ii := 0 To MaxDevNameLen do
        tempStr := tempStr + DeviceList[i].szDeviceName[ii];
    lstDevice.Items.Add(tempStr);
  end;

  lstModule.Enabled := False;
  labModule.Enabled := False;
  labChannel.Enabled := False;
  lstChannel.Enabled := False;
  cmdRun.Enabled := False;end;

procedure Tfrmstart.lstDeviceClick(Sender: TObject);
var
  tempNum, i, ii         : Integer;
  nOutEntries            : Smallint;
  TestRes                : Boolean;
  TempStr                : String;
  dwDeviceNum            : Longint;
begin
  lstModule.Items.Clear;
  lstChannel.Items.Clear;
  {lstVoltageRange.Items.Clear;}
  {lstExpChl.Clear;}

  tempNum := Pos('DEMO', lstDevice.Items[lstDevice.ItemIndex]);
  if (tempNum <> 0) then
     TestRes := True
  else
     TestRes := False;

  { Avoid to open Advantech Demo Card }
  If (TestRes) Then
  begin
    labModule.Enabled := False;
    lstModule.Enabled := False;
    labChannel.Enabled := False;
    lstChannel.Enabled := False;
    {labVoltageRange.Enabled := False;}
    {lstVoltageRange.Enabled := False;}
    {labExpChl.Enabled := False;}
    {lstExpChl.Enabled := False;}
    {labThermoCouple.Enabled := False;}
    {lstThermoCouple.Enabled := False;}
    lstChannel.Items.Add('No Use');
    cmdRun.Enabled := False;
  end;

  If (Not TestRes) Then
  begin
    { Check if there is any device attached on this COM or CAN }
    gnNumOfSubdevices := DeviceList[lstDevice.ItemIndex].nNumOfSubdevices;
    if (gnNumOfSubdevices > MaxDev) then
       gnNumOfSubdevices := MaxDev;

    dwDeviceNum := DeviceList[lstDevice.ItemIndex].dwDeviceNum;

    { COM and CAN bus }
    if (gnNumOfSubdevices <> 0) then
    begin
       ErrCde := DRV_DeviceGetSubList(dwDeviceNum, SubDeviceList[0], gnNumOfSubdevices, nOutEntries);
       If (ErrCde <> 0) Then
       begin
            DRV_GetErrorMessage(ErrCde, pszErrMsg);
            Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
            Exit;
       end;

       if (gnNumOfSubdevices > 0) then
       begin
            For i := 0 To (gnNumOfSubdevices - 1) do
            begin
                 tempStr := '';
                 For ii := 0 To MaxDevNameLen do
                     tempStr := tempStr + SubDevicelist[i].szDeviceName[ii];
                 lstModule.Items.Add(tempStr);
            end;
            lstModule.Enabled := True;
            labModule.Enabled := True;
       end;

       labChannel.Enabled := True;
       lstChannel.Enabled := True;
       {labVoltageRange.Enabled := True;}
       {lstVoltageRange.Enabled := True;}
       cmdRun.Enabled := True;
    end;

    { PCL DAS & DIO card }
    if (gnNumOfSubdevices = 0) then
    begin
         dwDeviceNum := DeviceList[lstDevice.ItemIndex].dwDeviceNum;
         ErrCde := DRV_DeviceOpen(dwDeviceNum, DeviceHandle);
         If (ErrCde <> 0) Then
         begin
            DRV_GetErrorMessage(ErrCde, pszErrMsg);
            Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
            Exit;
         end;

         ptDevGetFeatures.buffer := @lpDevFeatures;
         ErrCde := DRV_DeviceGetFeatures(DeviceHandle, ptDevGetFeatures);
         If (ErrCde <> 0) Then
         begin
            DRV_GetErrorMessage(ErrCde, pszErrMsg);
            Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
            Exit;
         end;

         tempNum := Trunc(lpDevFeatures.usMaxDOChl / 8);
         if (tempNum > 0) then
         begin
              For i := 0 To (tempNum - 1) do
              begin
                   tempStr := 'Port#' + IntToStr(i);
                   lstChannel.Items.Add(tempStr);
              end;
              labChannel.Enabled := True;
              lstChannel.Enabled := True;
              cmdRun.Enabled := True;
         end;
    end;
  end;
end;

procedure Tfrmstart.lstModuleClick(Sender: TObject);
var
    tempNum, i, ii         : Integer;
    dwDeviceNum            : Longint;
    TempStr                : String;
begin
     lstChannel.Items.Clear;
     { lstVoltageRange.Items.Clear; }
     { lstExpChl.Clear; }

     { open COM device or CAN device }
     dwDeviceNum := SubDevicelist[lstModule.ItemIndex].dwDeviceNum;
     ErrCde := DRV_DeviceOpen(dwDeviceNum, DeviceHandle);
     If (ErrCde <> 0) Then
     begin
          DRV_GetErrorMessage(ErrCde, pszErrMsg);
          Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
          Exit;
     end
     Else
       bRun := True;

     ptDevGetFeatures.buffer := @lpDevFeatures;
     ErrCde := DRV_DeviceGetFeatures(DeviceHandle, ptDevGetFeatures);
     If (ErrCde <> 0) Then
     begin
          DRV_GetErrorMessage(ErrCde, pszErrMsg);
          Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
          Exit;
     end;

     { Add Digital input channel items }
     tempNum := Trunc(lpDevFeatures.usMaxDOChl / 8);
     if (tempNum >= 0) then
     begin
          For i := 0 To (tempNum-1) do
          begin
               tempStr := 'Port#' + IntToStr(i);
               lstChannel.Items.Add(tempStr);
          end;
          labChannel.Enabled := True;
          lstChannel.Enabled := True;
          cmdRun.Enabled := True;
     end;
end;
end.
