unit GainListForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Global;

type
  TfrmGainList = class(TForm)
    Label1: TLabel;
    lstGainCtrl: TListView;
    cmbGain: TComboBox;
    btnExit: TButton;
    procedure SetGainList();
    procedure cmbGainChange(Sender: TObject);
    procedure lstGainCtrlClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmGainList: TfrmGainList;

implementation

{$R *.dfm}

procedure TfrmGainList.SetGainList();
var
    i           : integer;
    GainItem    : TListItem;
    temp        : Smallint;

begin
    lstGainCtrl.Clear();
    cmbGain.Clear();

    for i := 0 to lpDevFeatures.usNumGain-1 do
        cmbGain.Items.Add(lpDevFeatures.glGainList[i].szGainStr);
    cmbGain.ItemIndex := 0;

    for i:=0 to usChanNum-1 do
    begin
        GainItem := lstGainCtrl.Items.Add();
        GainItem.Caption := 'chan '+ IntToStr(usStartChan+i);
        GainItem.SubItems.Add(lpDevFeatures.glGainList[usGainIndx[usStartChan+i]].szGainStr );
        temp :=  (lpDevConfig_AI.ulChanConfig  and (1 shl (usStartChan+i)));
        if( temp >0 )  then
           GainItem.SubItems.Add( 'Differential' )
        else
           GainItem.SubItems.Add( 'Single-Ended' );
    end;

end;
procedure TfrmGainList.cmbGainChange(Sender: TObject);
begin
       if( lstGainCtrl.ItemIndex < 0 ) then
       Exit;

   lstGainCtrl.Items[lstGainCtrl.ItemIndex].SubItems[0] :=
   lpDevFeatures.glGainList[cmbGain.ItemIndex].szGainStr;
   usGainIndx[usStartChan+lstGainCtrl.ItemIndex] := cmbGain.ItemIndex;

end;

procedure TfrmGainList.lstGainCtrlClick(Sender: TObject);
begin
       if( lstGainCtrl.ItemIndex < 0 ) then
       Exit;
       cmbGain.ItemIndex := usGainIndx[usStartChan+lstGainCtrl.ItemIndex];

end;

procedure TfrmGainList.btnExitClick(Sender: TObject);
begin
  Close();
end;

end.
