unit formrun;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Driver, Global;

type
  Tfrmrun = class(TForm)
    txtCountRead: TEdit;
    CmdExit: TButton;
    GroupSample: TGroupBox;
    hscrFreq: TScrollBar;
    labStart: TLabel;
    labEnd: TLabel;
    procedure CmdExitClick(Sender: TObject);
    procedure hscrFreqChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmrun: Tfrmrun;

implementation

uses formstar;

var
   Response       : Integer;
{$R *.DFM}

procedure Tfrmrun.CmdExitClick(Sender: TObject);
begin
    { Reset the output pulse }
    ErrCde := DRV_CounterReset(DeviceHandle, ptCounterPulseStart.counter);
    If (ErrCde <> 0) Then
    begin
         DRV_GetErrorMessage(ErrCde, pszErrMsg);
         Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
         Exit;
    end;
    frmRun.Close;
    Formstar.frmstart.Show;
end;

procedure Tfrmrun.hscrFreqChange(Sender: TObject);
begin
    { Reset the output pulse }
    ErrCde := DRV_CounterReset(DeviceHandle, ptCounterPulseStart.counter);
    If (ErrCde <> 0) Then
    begin
         DRV_GetErrorMessage(ErrCde, pszErrMsg);
         Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
         Exit;
    end;

    { Change the pulse period }
    ptCounterPulseStart.period := hscrFreq.Position / 1000;
    { Change the pulse period value }
    txtCountRead.Text := IntToStr(hscrFreq.Position);
    ErrCde := DRV_CounterPulseStart(DeviceHandle, ptCounterPulseStart);
    If (ErrCde <> 0) Then
    begin
         DRV_GetErrorMessage(ErrCde, pszErrMsg);
         Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
         Exit;
    end;
end;

procedure Tfrmrun.FormShow(Sender: TObject);
begin
     hscrFreq.Position := Trunc(ptCounterPulseStart.period * 1000);
     txtCountRead.Text := IntToStr(hscrFreq.Position);
end;

end.
