VERSION 5.00
Begin VB.Form frmDevSel 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Temperature Measurement Demo: Select  Device"
   ClientHeight    =   4545
   ClientLeft      =   5100
   ClientTop       =   3780
   ClientWidth     =   6300
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4545
   ScaleWidth      =   6300
   Begin VB.ListBox lstThermocouple 
      Height          =   840
      Left            =   4320
      TabIndex        =   11
      Top             =   1920
      Width           =   1695
   End
   Begin VB.ListBox lstExpChl 
      Height          =   1035
      Left            =   4320
      TabIndex        =   10
      Top             =   480
      Width           =   1695
   End
   Begin VB.ListBox lstVoltageRange 
      Height          =   1035
      Left            =   2040
      TabIndex        =   8
      Top             =   3240
      Width           =   1935
   End
   Begin VB.ListBox lstChannel 
      Height          =   1035
      Left            =   240
      TabIndex        =   5
      Top             =   3240
      Width           =   1455
   End
   Begin VB.ListBox lstModule 
      Enabled         =   0   'False
      Height          =   840
      Left            =   240
      TabIndex        =   4
      Top             =   1920
      Width           =   3735
   End
   Begin VB.CommandButton cmdExit 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "E&xit"
      Height          =   495
      Left            =   4560
      TabIndex        =   2
      Top             =   3840
      Width           =   1095
   End
   Begin VB.CommandButton cmdRun 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "&Run..."
      Height          =   495
      Left            =   4560
      TabIndex        =   1
      Top             =   3120
      Width           =   1095
   End
   Begin VB.ListBox lstDevice 
      Height          =   1035
      Left            =   240
      TabIndex        =   0
      Top             =   480
      Width           =   3735
   End
   Begin VB.Label labModule 
      Caption         =   "Select a Module"
      Height          =   255
      Left            =   480
      TabIndex        =   13
      Top             =   1680
      Width           =   3375
   End
   Begin VB.Label labThermocouple 
      Caption         =   "Thermocouple Type"
      Height          =   255
      Left            =   4320
      TabIndex        =   12
      Top             =   1680
      Width           =   1815
   End
   Begin VB.Label labExpChl 
      Alignment       =   1  'Right Justify
      Caption         =   "Exp. card channel"
      Height          =   255
      Left            =   4320
      TabIndex        =   9
      Top             =   240
      Width           =   1575
   End
   Begin VB.Label labVoltageRange 
      Caption         =   "DAS Card Voltage Range"
      Height          =   255
      Left            =   2040
      TabIndex        =   7
      Top             =   3000
      Width           =   2175
   End
   Begin VB.Label labChannel 
      Alignment       =   1  'Right Justify
      Caption         =   "DAS card channel"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   3000
      Width           =   1575
   End
   Begin VB.Label labDevLst 
      Caption         =   "Select a device from list"
      Height          =   255
      Index           =   0
      Left            =   480
      TabIndex        =   3
      Top             =   240
      Width           =   3375
   End
End
Attribute VB_Name = "frmDevSel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim gnNumOfSubdevices As Integer
Dim lpAIGetConfig As DEVCONFIG_AI
Dim tempStr As String
Dim bRun As Boolean
Function TestStr(SStr As String, TStr As String) As Boolean
  Dim lenS, lenT As Integer
  Dim i As Integer

  TestStr = False
  lenS = Len(SStr)
  lenT = Len(TStr)

  ' if source string is empty, return true
  If SStr = "" Then
    TestStr = True
    Exit Function
  End If

  ' if it find a target string in source string, return true
  For i = 1 To (lenS - lenT + 1)
    If (Mid(SStr, i, lenT) = TStr) Then
      TestStr = True
    End If
  Next i
End Function

Private Sub cmdExit_Click()
  ErrCde = DRV_DeviceClose(DeviceHandle)
  If bRun Then
    If (ErrCde <> 0) Then
      DRV_GetErrorMessage ErrCde, szErrMsg
      Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
    End If
  End If
  End
End Sub

Private Sub cmdRun_Click()
  Dim tempNum As Integer
  Dim BoardID As Integer

  ptTCMuxRead.DasChan = lstChannel.ListIndex
  ' Gain code no use for ADAM series
  BoardID = lpAIGetConfig.Daughter(lstChannel.ListIndex).dwBoardID
  If gnNumOfSubdevices = 0 Then
       If BoardID > 0 And BoardID <> BD_PCLD8710 Then
          ptTCMuxRead.DasGain = 0
          ptTCMuxRead.ExpChan = lstExpChl.ListIndex
       Else
          tempNum = lstVoltageRange.ListIndex
          ptTCMuxRead.DasGain = lpDevFeatures.glGainList(tempNum).usGainCde
          ptTCMuxRead.ExpChan = 0
       End If
  End If

  ptTCMuxRead.TCType = lstThermocouple.ListIndex

  frmRun.Show
  frmRun.tmrRead.Enabled = True
  frmRun.cmdRead.SetFocus
  frmDevSel.Hide
End Sub

Private Sub Form_Load()
  Dim gnNumOfDevices As Integer
  Dim nOutEntries As Integer
  Dim i, j As Integer
  Dim lpDeviceList As Long

  ' initialize the device open/close flag
  bRun = False

  ErrCde = DRV_DeviceGetNumOfList(gnNumOfDevices)
  If (ErrCde <> 0) Then
    DRV_GetErrorMessage ErrCde, szErrMsg
    Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
    Exit Sub
  End If

  If (gnNumOfDevices > MaxDev) Then
    gnNumOfDevices = MaxDev
  End If

  ' retrieve the information of all installed devices
  lpDeviceList = DRV_GetAddress(devicelist(0))
  ErrCde = DRV_DeviceGetList(lpDeviceList, MaxEntries, nOutEntries)
  If (ErrCde <> 0) Then
    DRV_GetErrorMessage ErrCde, szErrMsg
    Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
    Exit Sub
  End If

  ' Display a list of device name
  For i = 0 To (gnNumOfDevices - 1)
    tempStr = ""
    For j = 0 To MaxDevNameLen
      tempStr = tempStr + Chr(devicelist(i).szDeviceName(j))
    Next j
      lstDevice.AddItem tempStr
  Next i


  If (gnNumOfDevices > MaxDev) Then
    gnNumOfDevices = MaxDev
  End If

  ' Add selectable items of Thermocouple type
  lstThermocouple.AddItem "J type"            ' 0
  lstThermocouple.AddItem "K type"            ' 1
  lstThermocouple.AddItem "S type"            ' 2
  lstThermocouple.AddItem "T type"            ' 3
  lstThermocouple.AddItem "B type"            ' 4
  lstThermocouple.AddItem "R type"            ' 5
  lstThermocouple.AddItem "E type"            ' 6

  ' Set the default selection of thermocouple type
  lstThermocouple.ListIndex = 0

  ' Since no display on screen, you'd better to disable the following function
  labModule.Enabled = False
  lstModule.Enabled = False
  labChannel.Enabled = False
  lstChannel.Enabled = False
  labVoltageRange.Enabled = False
  lstVoltageRange.Enabled = False
  labExpChl.Enabled = False
  lstExpChl.Enabled = False
  labThermocouple.Enabled = False
  lstThermocouple.Enabled = False
  cmdRun.Enabled = False
End Sub

Private Sub lstChannel_Click()

     labExpChl.Enabled = False
     lstExpChl.Enabled = False
     lstExpChl.Clear
     ' Add Expansion card channel
        If (lpAIGetConfig.Daughter(lstChannel.ListIndex).dwBoardID > 0) Then
            For i = 0 To (lpAIGetConfig.Daughter(lstChannel.ListIndex).usNum - 1)
                tempStr = "Chan#" + Str(i)
                lstExpChl.AddItem tempStr
            Next i
            lstExpChl.Text = lstExpChl.List(0)
            labExpChl.Enabled = True
            lstExpChl.Enabled = True
        End If
End Sub

Private Sub lstDevice_Click()
  Dim i, ii As Integer
  Dim tempNum As Integer
  Dim TestRes As Boolean
  Dim nOutEntries As Integer
  Dim lpSubDeviceList As Long
  Dim dwDeviceNum As Long

  lstModule.Clear
  lstChannel.Clear
  lstVoltageRange.Clear
  lstExpChl.Clear

  ' Avoid to open Advantech Demo Card
  TestRes = TestStr(lstDevice.Text, "DEMO")
  If (TestRes) Then
    labModule.Enabled = False
    lstModule.Enabled = False
    labChannel.Enabled = False
    lstChannel.Enabled = False
    labVoltageRange.Enabled = False
    lstVoltageRange.Enabled = False
    labExpChl.Enabled = False
    lstExpChl.Enabled = False
    labThermocouple.Enabled = False
    lstThermocouple.Enabled = False
    cmdRun.Enabled = False
    lstChannel.AddItem "No Use"
  End If

  If (Not TestRes) Then
    ' Check if there is any device attatched on this COM port or CAN
    gnNumOfSubdevices = devicelist(lstDevice.ListIndex).nNumOfSubdevices
    If (gnNumOfSubdevices > MaxDev) Then
      gnNumOfSubdevices = MaxDev
    End If

    ' retrieve the information of all installed devices
    If (gnNumOfSubdevices <> 0) Then
      dwDeviceNum = devicelist(lstDevice.ListIndex).dwDeviceNum
      lpSubDeviceList = DRV_GetAddress(SubDevicelist(0))
      ErrCde = DRV_DeviceGetSubList(dwDeviceNum, lpSubDeviceList, gnNumOfSubdevices, nOutEntries)
      If (ErrCde <> 0) Then
        DRV_GetErrorMessage ErrCde, szErrMsg
        Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
        Exit Sub
      End If
      For i = 0 To (gnNumOfSubdevices - 1)
        tempStr = ""
        For ii = 0 To MaxDevNameLen
            tempStr = tempStr + Chr(SubDevicelist(i).szDeviceName(ii))
        Next ii
        lstModule.AddItem tempStr
      Next i
      lstModule.Enabled = True
      labModule.Enabled = True
   End If

    ' Open PCL card device
    If (gnNumOfSubdevices = 0) Then
        dwDeviceNum = devicelist(lstDevice.ListIndex).dwDeviceNum
        ErrCde = DRV_DeviceOpen(dwDeviceNum, DeviceHandle)
        If (ErrCde <> 0) Then
            DRV_GetErrorMessage ErrCde, szErrMsg
            Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
            Exit Sub
        Else
            bRun = True
        End If

        ptDevGetFeatures.buffer = DRV_GetAddress(lpDevFeatures)
        ErrCde = DRV_DeviceGetFeatures(DeviceHandle, ptDevGetFeatures)
        If (ErrCde <> 0) Then
            DRV_GetErrorMessage ErrCde, szErrMsg
            Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
            Exit Sub
        End If

        ptAIGetConfig.buffer = DRV_GetAddress(lpAIGetConfig)
        ErrCde = DRV_AIGetConfig(DeviceHandle, ptAIGetConfig)
        If (ErrCde <> 0) Then
            DRV_GetErrorMessage ErrCde, szErrMsg
            Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
            Exit Sub
        End If
        

        ' Add thermo channel item
        tempNum = lpDevFeatures.usMaxAISiglChl
        For i = 0 To (tempNum - 1)
            tempStr = "Chan#" + Str(i)
            lstChannel.AddItem tempStr, i
        Next i
        lstChannel.Text = lstChannel.List(0)

        For i = 0 To (lpDevFeatures.usNumGain - 1)
            tempStr = ""
            For ii = 0 To 15
                tempStr = tempStr + Chr(lpDevFeatures.glGainList(i).szGainStr(ii))
            Next ii
            lstVoltageRange.AddItem tempStr
        Next i
        lstVoltageRange.Text = lstVoltageRange.List(0)

        'Since you have selected a PC-Lab Card, you can choose the channel and gain code as you want
        labChannel.Enabled = True
        lstChannel.Enabled = True
        lstVoltageRange.Enabled = True
        labVoltageRange.Enabled = True
        labThermocouple.Enabled = True
        lstThermocouple.Enabled = True
        cmdRun.Enabled = True
    End If
  End If
End Sub


Private Sub lstModule_Click()
    Dim i, ii As Integer
    Dim dwDeviceNum As Long
    Dim tempNum As Integer

    lstChannel.Clear
    lstVoltageRange.Clear
    ' open COM device or CAN device
    dwDeviceNum = SubDevicelist(lstModule.ListIndex).dwDeviceNum
    ErrCde = DRV_DeviceOpen(dwDeviceNum, DeviceHandle)
    If (ErrCde <> 0) Then
       DRV_GetErrorMessage ErrCde, szErrMsg
       Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
       Exit Sub
    Else
       bRun = True
    End If

    ptDevGetFeatures.buffer = DRV_GetAddress(lpDevFeatures)
    ErrCde = DRV_DeviceGetFeatures(DeviceHandle, ptDevGetFeatures)
    If (ErrCde <> 0) Then
       DRV_GetErrorMessage ErrCde, szErrMsg
       Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
       Exit Sub
    End If

    ' Add analog input channel item
      tempNum = lpDevFeatures.usMaxAIDiffChl
      If (tempNum > 0) Then
        For i = 0 To (tempNum - 1)
          temp$ = "Chan#" + Str(i)
          lstChannel.AddItem temp$, i
        Next i
        lstChannel.Text = lstChannel.List(0)
        labChannel.Enabled = True
        lstChannel.Enabled = True
      End If

      ' add gain code list
      tempNum = lpDevFeatures.usNumGain
      If (lpDevFeatures.usNumGain > 0) Then
        For i = 0 To (lpDevFeatures.usNumGain - 1)
          tempStr = ""
          For ii = 0 To 15
              tempStr = tempStr + Chr(lpDevFeatures.glGainList(i).szGainStr(ii))
          Next ii
          lstVoltageRange.AddItem tempStr
        Next i
        lstVoltageRange.Text = lstVoltageRange.List(0)
        lstVoltageRange.Enabled = True
        labVoltageRange.Enabled = True
      End If

      labThermocouple.Enabled = True
      lstThermocouple.Enabled = True
      cmdRun.Enabled = True
End Sub


