/*****************************************************************************
 *  FILE        : CAN841.H
 *  DATE        : 11-3-95'
 *  Version     : V1.0
 *  Description : Prototype for CAN841x.LIB
 *
 *
 *
 ******************************************************************************/

#define  BYTE  unsigned char
#define  UI    unsigned int
#define  UL    unsigned long

typedef struct {
        BYTE acc_code;
	BYTE acc_mask;
        BYTE bt0;
	BYTE bt1;
}CAN_STRUCT;

typedef struct {
        UI   id;
        BYTE rtr;
        BYTE dlen;
        BYTE data[8];
} MSG_STRUCT;
#define PACKRECEMAX  10
#define PACKSENDMAX  20
#define PACKRETRYMAX  5
#define PACKTIMEOUT  18
#define PACKSENDINTERVAL 25
#define PACKORDERMAX 37
typedef struct {
    UI   id; //send pack note address
    BYTE timeout;
    BYTE pri;  //PRI
    UI   order; //send order
    BYTE plen ; //pack len
    BYTE flag ; //flag: 1=receving complete
    BYTE data[256]; //data buffer
}MSG_RECE_STRUCT;
typedef far struct {
    BYTE port;
    UI   id; //send pack note address
    BYTE timeout;
    BYTE retry;
    BYTE pri;  //PRI
    UI   order; //send order
    BYTE plen ; //pack len
    BYTE flag ; //flag:
    BYTE data[256]; //data buffer
}MSG_SEND_STRUCT;

typedef struct{
   BYTE port;
   UI rid;
   BYTE flag;
   BYTE data[8];
}MSG_REPLY_STRUCT;

extern  int can_err_no;

/*===============  functions declaration ==========================*/
/* set can card hardware setting , if successful return 1, else return 0*/
/*----------------------------------------------------------------------
input:
   segment :set memory decode segment value, 0xC000 to 0xDF00
   irq1    : can port#1 irq number
   irq2    : can port#2 irq number
----------------------------------------------------------------------*/


int canInitHW( UI segment, BYTE irq1, BYTE irq2);

int canReleaseHW();
/* reset can controller */
int  canReset( BYTE port );

/* initiallize and configure can controller */
int  canConfig( BYTE port, CAN_STRUCT can);

/* change can controller to normal run mode */
int  canNormalRun( BYTE port );

/* send a message */
int canSendMsg( BYTE  port, MSG_STRUCT send_msg);

/* receive a message */
int  canReceiveMsg( BYTE port, MSG_STRUCT *msg_ptr);

int _SendPack(MSG_SEND_STRUCT *send);
int RecePack(int *addr,int *len,char *buf);
int SendPack(int port,int addr,int len,char *buf);
void PackReply(void);
extern void interrupt  ( *oldClock ) (void);     //DOSʱж
void interrupt newClock ();
