/***************************************************************************
* FILE	       : demo.c							   *
* DATE	       : 12-27-1995						   *
* Version      : V1.0							   *
* Description  : THis test program is call can841x.lib to implement CAN	   *
*		 controller send and recieve messages.			   *
****************************************************************************/
#include "can841.h"	/* Library function declaration	*/
#include "dos.h"
#include "stdio.h"
#include "stdlib.h"
#include "conio.h"
#include "string.h"
/*--------------------------------------------------------------------------
--------------------------------------------------------------------------*/
/* define can controller interrupt connect to PC irq number */
#define	CAN1_IRQ	3   /*	0 mean polling */
#define	CAN2_IRQ	4 /* 0	mean polling */

#define	PORT1		0
#define	PORT2		1

#define	FAIL		0
#define	SUCCESS		1

extern MSG_RECE_STRUCT Rece_Buf[PACKRECEMAX];
extern MSG_SEND_STRUCT Send_Buf[PACKSENDMAX];

void main(void)
{
    /* declare the can card segment address */
    UI gSegment=0xDA00;
    CAN_STRUCT	  can1,	can2;
    MSG_STRUCT smsg1, smsg2;
    MSG_STRUCT rmsg1, rmsg2;
    UI	i,j;
    char buf[256];
    int addr,len;

    memset(&Rece_Buf,0,sizeof(Rece_Buf));

    if(	canInitHW(gSegment,CAN1_IRQ,CAN2_IRQ)==	FAIL)
    {
      clrscr();
      cprintf("\n\n hardware initial is error ");
      return;
    }

    /*---- reset can controller	*/
    canReset(PORT1);
    canReset(PORT2);

    can1.acc_code=0;		/*			*/
    can1.acc_mask=0xff;		/*			*/
    can1.bt0=3;		/* baud	rate 125Kbps	  */
    can1.bt1=0x1c;
    if(	canConfig(PORT1,can1)==	FAIL)
    {
      clrscr();
      cprintf("\n\n can controller port %d configure is error ", 1);
      return;
    }
    memcpy(&can2, &can1	,sizeof(CAN_STRUCT));
    if(	canConfig(PORT2,can2)==	FAIL)
    {
      clrscr();
      cprintf("\n\n can controller port %d configure is error ", 2);
      return;
    }
    canNormalRun( PORT1);	/* Put CAN1,2 to normal	mode */
    canNormalRun( PORT2);

    oldClock = getvect( 0x1c );           // Initilize clock interrupt
    setvect(0x1c, newClock);

    clrscr();

    smsg1.id = 0x015;		    /* set ID =	8	    */
    smsg1.rtr=0;		    /* data lengths = 8	    */
    smsg1.dlen=8;
    for (j=0; j<249;j++)
    {
       for(i=0;i<smsg1.dlen;i++)
       smsg1.data[i] =i+j;
       canSendMsg( PORT1, smsg1);	// send	to CAN1
       delay(50);
    }

   getchar();
   //---- reset can controller
    setvect(0x1c, oldClock);
    canReset(PORT1);
    canReset(PORT2);
	canExitHW();
//    clrscr();
}
