Attribute VB_Name = "Param"
'############################################################################
'****************************************************************************
'              Copyright (C) 2000-3, Advantech Automation Corp.
'      THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY
'         INFORMATION WHICH IS THE PROHERTY OF ADVANTECH AUTOMATION CORP.
'
'   ANY DISCLOSURE, USE, OR REPRODUCTION, WITHOUT WRITTEN AUTHORIZATION FROM
'             ADVANTECH AUTOMATION CORP., IS STRICTLY PROHIBITED
'****************************************************************************
'############################################################################

' File:        PARAS.H
' Created:     01/03/2003
' Description: Get parameter definition headfile.
' ============================================================================
' VERSION HISTORY
' 01/03/2003  Create
' ============================================================================
' Notes:
' 1. From 0x0000 to 0x0FFF : General definition
'
' 2. From 0x1000 to 0x1FFF : AI related
'
' 3. From 0x2000 to 0x2FFF : AO related
'
' 4. From 0x3000 to 0x3FFF : DI related
'
' 5. From 0x4000 to 0x4FFF : DO related
'
' 6. From 0x5000 to 0x5FFF : Counter/Timer related


'****************************************************************************
'    Constant Definition
'****************************************************************************
Global Const CFG_DeviceNumber = &H0
Global Const CFG_BoardID = &H1
Global Const CFG_SwitchID = &H2
Global Const CFG_BaseAddress = &H3
Global Const CFG_Interrupt = &H4
Global Const CFG_BusNumber = &H5
Global Const CFG_SlotNumber = &H6
Global Const CFG_OnSystem = &H7

' ==================================
' 0x1000 ~ 0x1fff for AI Group
' ----------------------------------

' ----------------------------------
' 0x2000 ~ 0x2fff for AO Group
' ----------------------------------
' sub group 0x2000 ~ 0x27ff for AO General ID
Global Const AO_RANGE_SETTING = &H2000

Global Const AO_RANGE_SETTINGL_NAME = "AO_RANGE_SETTING"

' sub group 0x2800 ~ 0x2fff for AO other ID


' ----------------------------------
' 0x3000 ~ 0x3fff for DI Group
' ----------------------------------
' sub group 0x3000 ~ 0x37ff for DI General ID
Global Const CFG_DioDirection = &H3000            ' each bit for one Auxiliary DIO channel for PCI-1755.
Global Const CFG_DioFdioDirection = &H3001        ' 32DI(0)/32DO(1)/ 16 DIO(2) / 8DIO(3) for PCI-1755
Global Const CFG_DioTerminator = &H3002           ' Bit 0: DI terminator (DI_TERM),ON (0) or OFF(1) for PCI-1755                                                      // Bit 1: DO terminator (DI_TERM) ON (0) or OFF(1) for PCI-1755
Global Const CFG_DiOperationMode = &H3003         ' normal mode (0), 8255 handshaking(1), Burst handshaking(2) for PCI-1755


' sub group 0x3800 ~ 0x3fff for DI General ID
Global Const CFG_DiStartMethod = &H3800         ' Software(1), External trigger(2), Pattern match(3)
Global Const CFG_DiStopMethod = &H3801          ' Software(1), External trigger(2), Pattern match(3)
Global Const CFG_DiPacerSource = &H3802         ' 30MHz(1), 15Mhz(2), 10MHz(3), Counter 0 OUT (4), External (5).
Global Const CFG_DiControlSignals = &H3803      ' Bit 0: External DI start signal control (STRRF), 0 rising edge, 1 falling edge.
                                                ' Bit 1: External DI stop signal control (STPRF), 0 rising edge, 1 falling edge.
                                                ' Bit 2: DI request signal control (REQRF), 0 rising edge, 1 falling edge.
                                                ' Bit 3: DI acknowledge signal control (ACKRF), 0 rising edge, 1 falling edge.
                                                ' Bit 4: DI sampling clock signal control (CLKRF), 0 rising edge, 1 falling edge
Global Const CFG_DiPatternMatchValue = &H3804


' ----------------------------------
' 0x4000 ~ 0x4fff for DO Group
' ----------------------------------
' sub group 0x4000 ~ 0x47ff for DO General ID

' sub group 0x4800 ~ 0x4fff for DO others ID
Global Const CFG_DoOperationMode = &H4800       ' Normal (0), Handahaking (1), Burst handshaking(2)
Global Const CFG_DoStartMethod = &H4801         ' Software(1), External signal(2)
Global Const CFG_DoStopMethod = &H4802          ' Software(1), External signal(2)
Global Const CFG_DoPacerSource = &H4803         ' 30, 15, 10 Mhz, Counter1, External signal (value range 1-5)
Global Const CFG_DoControlSignals = &H4804      ' Control signals
                                         '   Bit 0: External DO start signal control (STRRF), 0 rising edge, 1 falling edge.
                                         '   Bit 1: External DO stop signal control (STPRF), 0 rising edge, 1 falling edge.
                                         '   Bit 2: DO request signal control (REQRF), 0 rising edge, 1 falling edge.
                                         '   Bit 3: DO acknowledge signal control (ACKRF), 0 rising edge, 1 falling edge.
                                         '   Bit 4: DO sampling clock signal control (CLKRF), 0 rising edge, 1 falling edge
Global Const CFG_DoPresetValue = &H4805         ' DO status before transfering.

' ---------------------------------------
' 0x5000 ~ 0x5fff for Counter/Timer
' ---------------------------------------
' sub group 0x5000 ~ 0x57ff for Counter/Timer general ID
Global Const CFG_CounterCountValue = &H5000   ' 82C54 Counter 0-2 value

' sub group 0x5800 ~ 0x5fff for counter/Timer general ID

' Other ID
Global Const CFG_IrqDiChangeStatusChannel = &H6000        ' Change status channel number.
Global Const CFG_IrqDiTriggerSignals = &H6001             ' Each bit for each Auxiliary DIO channel


